      subroutine ebirate5(ny,nr,r,gain,loss)
c
c----CAMx v4.53 090209
c
c     EBIRATE5 computes species production and loss
c     for the EBI solver
c
c     Copyright 1996-2009
c     ENVIRON International Corporation
c     Created by the CMC version 5
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        ny   - dimension of gain and loss
c        nr   - dimension of r
c        r    - reaction rates (hr-1)
c        gain - species production (ppm/hr)
c        loss - species destruction (ppm/hr)
c
c --- Includes:
      implicit none
      include "camx.prm"
      include "ddmchm.com"
c
c --- Arguments:
      integer ny, nr, l
      real    loss(ny+1), gain(ny+1)
      real    r(nr)
c
c --- Entry Point:
c
c
c-----Calculate the species rates
c
c
c   NO2    NO     O    O3   NO3  N2O5  HNO3   O1D    OH  HONO
c   HO2    CO  HNO4  HO2H   SO2  SULF  CXO2  HCHO  COOH  MEOH
c  RO2R  ROOH  R2O2  RO2N  RNO3   MEK  PROD  CCO3   PAN  CO3H
c  CO2H  RCO3  PAN2  CCHO  RC3H  RC2H  BZCO  PBZN   BZO  MCO3
c  MPAN  TBUO  ACET  NPHE  PHEN  BZNO    XN  HCO3  HC2H  RCHO
c   GLY  MGLY  BACL  CRES  BALD  METH   MVK  ISPD  DCB1  DCB2
c  DCB3  ETHE  ISOP  TERP  ALK1  ALK2  ALK3  ALK4  ALK5  ARO1
c  ARO2  OLE1  OLE2  ETOH  MTBE  MBUT
c
        Loss(lNO2  )= +( 1.000)*r(  1)+( 1.000)*r(  5)+( 1.000)*r(  6)
     &                +( 1.000)*r(  8)+( 1.000)*r( 11)+( 1.000)*r( 14)
     &                +( 1.000)*r( 25)+( 1.000)*r( 32)+( 1.000)*r( 69)
     &                +( 1.000)*r( 79)+( 1.000)*r( 90)+( 1.000)*r(102)
     &                +( 1.000)*r(115)+( 1.000)*r(117)+( 1.000)*r(120)
c
        Gain(lNO2  )= +( 1.000)*r(  4)+( 1.000)*r(  7)+( 2.000)*r(  9)
     &                +( 2.000)*r( 10)+( 1.000)*r( 12)+( 1.000)*r( 14)
     &                +( 1.000)*r( 16)+( 1.000)*r( 23)+( 1.000)*r( 24)
     &                +( 1.000)*r( 26)+( 1.000)*r( 28)+( 1.000)*r( 31)
     &                +( 1.000)*r( 33)+( 0.610)*r( 34)+( 1.000)*r( 35)
     &                +( 0.800)*r( 39)+( 2.000)*r( 40)+( 1.000)*r( 46)
     &                +( 1.000)*r( 48)+( 1.000)*r( 51)+( 1.000)*r( 53)
     &                +( 1.000)*r( 56)+( 1.000)*r( 58)+( 1.000)*r( 65)
     &                +( 1.000)*r( 70)+( 1.000)*r( 71)+( 1.000)*r( 73)
        Gain(lNO2  ) = Gain(lNO2  )
     &                +( 1.000)*r( 80)+( 1.000)*r( 81)+( 1.000)*r( 83)
     &                +( 1.000)*r( 91)+( 1.000)*r( 92)+( 1.000)*r( 94)
     &                +( 1.000)*r(103)+( 1.000)*r(104)+( 1.000)*r(106)
     &                +( 1.000)*r(128)+( 0.338)*r(176)+( 1.000)*r(177)
     &                +( 0.187)*r(191)+( 0.474)*r(195)+( 0.391)*r(210)
c
        Loss(lNO   )= +( 1.000)*r(  4)+( 1.000)*r(  7)+( 1.000)*r(  9)
     &                +( 2.000)*r( 10)+( 1.000)*r( 21)+( 1.000)*r( 31)
     &                +( 1.000)*r( 46)+( 1.000)*r( 51)+( 1.000)*r( 56)
     &                +( 1.000)*r( 62)+( 1.000)*r( 71)+( 1.000)*r( 81)
     &                +( 1.000)*r( 92)+( 1.000)*r(104)+( 1.000)*r(128)
c
        Gain(lNO   )= +( 1.000)*r(  1)+( 1.000)*r(  5)+( 1.000)*r( 14)
     &                +( 1.000)*r( 15)+( 1.000)*r( 22)
c
        Loss(lO    )= +( 1.000)*r(  2)+( 1.000)*r(  3)+( 1.000)*r(  4)
     &                +( 1.000)*r(  5)+( 1.000)*r(  6)+( 1.000)*r(164)
     &                +( 1.000)*r(168)+( 1.000)*r(188)+( 1.000)*r(192)
     &                +( 1.000)*r(196)+( 1.000)*r(207)+( 1.000)*r(211)
     &                +( 1.000)*r(217)
c
        Gain(lO    )= +( 1.000)*r(  1)+( 1.000)*r( 16)+( 1.000)*r( 17)
     &                +( 1.000)*r( 20)
c
        Loss(lO3   )= +( 1.000)*r(  3)+( 1.000)*r(  7)+( 1.000)*r(  8)
     &                +( 1.000)*r( 17)+( 1.000)*r( 18)+( 1.000)*r( 30)
     &                +( 1.000)*r( 36)+( 1.000)*r(162)+( 1.000)*r(167)
     &                +( 1.000)*r(171)+( 1.000)*r(179)+( 1.000)*r(186)
     &                +( 1.000)*r(190)+( 1.000)*r(194)+( 1.000)*r(205)
     &                +( 1.000)*r(209)+( 1.000)*r(215)
c
        Gain(lO3   )= +( 1.000)*r(  2)+( 0.250)*r( 72)+( 0.250)*r( 82)
     &                +( 0.250)*r( 93)+( 0.250)*r(105)
c
        Loss(lNO3  )= +( 1.000)*r(  9)+( 1.000)*r( 11)+( 1.000)*r( 14)
     &                +( 1.000)*r( 15)+( 1.000)*r( 16)+( 1.000)*r( 26)
     &                +( 1.000)*r( 39)+( 2.000)*r( 40)+( 1.000)*r( 48)
     &                +( 1.000)*r( 53)+( 1.000)*r( 58)+( 1.000)*r( 65)
     &                +( 1.000)*r( 73)+( 1.000)*r( 83)+( 1.000)*r( 94)
     &                +( 1.000)*r(106)+( 1.000)*r(129)+( 1.000)*r(132)
     &                +( 1.000)*r(135)+( 1.000)*r(148)+( 1.000)*r(151)
     &                +( 1.000)*r(154)+( 1.000)*r(156)+( 1.000)*r(157)
     &                +( 1.000)*r(160)+( 1.000)*r(163)+( 1.000)*r(172)
        Loss(lNO3  ) = Loss(lNO3  )
     &                +( 1.000)*r(187)+( 1.000)*r(191)+( 1.000)*r(195)
     &                +( 1.000)*r(206)+( 1.000)*r(210)+( 1.000)*r(216)
c
        Gain(lNO3  )= +( 1.000)*r(  6)+( 1.000)*r(  8)+( 1.000)*r( 12)
     &                +( 1.000)*r( 27)+( 0.390)*r( 34)
c
        Loss(lN2O5 )= +( 1.000)*r( 12)+( 1.000)*r( 13)
c
        Gain(lN2O5 )= +( 1.000)*r( 11)
c
        Loss(lHNO3 )= +( 1.000)*r( 27)+( 1.000)*r( 28)
c
        Gain(lHNO3 )= +( 2.000)*r( 13)+( 1.000)*r( 25)+( 0.200)*r( 39)
     &                +( 1.000)*r(129)+( 1.000)*r(132)+( 1.000)*r(135)
     &                +( 1.000)*r(148)+( 1.000)*r(151)+( 1.000)*r(154)
     &                +( 1.000)*r(156)+( 1.000)*r(157)+( 1.000)*r(160)
     &                +( 0.500)*r(163)+( 0.150)*r(172)
c
        Loss(lO1D  )= +( 1.000)*r( 19)+( 1.000)*r( 20)
c
        Gain(lO1D  )= +( 1.000)*r( 18)
c
        Loss(lOH   )= +( 1.000)*r( 21)+( 1.000)*r( 24)+( 1.000)*r( 25)
     &                +( 1.000)*r( 26)+( 1.000)*r( 27)+( 1.000)*r( 29)
     &                +( 1.000)*r( 30)+( 1.000)*r( 35)+( 1.000)*r( 42)
     &                +( 1.000)*r( 43)+( 1.000)*r( 44)+( 1.000)*r( 45)
     &                +( 1.000)*r(125)+( 1.000)*r(130)+( 1.000)*r(133)
     &                +( 1.000)*r(136)+( 1.000)*r(138)+( 1.000)*r(140)
     &                +( 1.000)*r(141)+( 1.000)*r(143)+( 1.000)*r(147)
     &                +( 1.000)*r(150)+( 1.000)*r(153)+( 1.000)*r(155)
     &                +( 1.000)*r(158)+( 1.000)*r(161)+( 1.000)*r(166)
        Loss(lOH   ) = Loss(lOH   )
     &                +( 1.000)*r(170)+( 1.000)*r(174)+( 1.000)*r(176)
     &                +( 1.000)*r(178)+( 1.000)*r(180)+( 1.000)*r(182)
     &                +( 1.000)*r(184)+( 1.000)*r(185)+( 1.000)*r(189)
     &                +( 1.000)*r(193)+( 1.000)*r(197)+( 1.000)*r(198)
     &                +( 1.000)*r(199)+( 1.000)*r(200)+( 1.000)*r(201)
     &                +( 1.000)*r(202)+( 1.000)*r(203)+( 1.000)*r(204)
     &                +( 1.000)*r(208)+( 1.000)*r(212)+( 1.000)*r(213)
     &                +( 1.000)*r(214)
c
        Gain(lOH   )= +( 2.000)*r( 19)+( 1.000)*r( 22)+( 1.000)*r( 28)
     &                +( 1.000)*r( 31)+( 0.390)*r( 34)+( 1.000)*r( 36)
     &                +( 0.800)*r( 39)+( 2.000)*r( 41)+( 0.350)*r(141)
     &                +( 1.000)*r(142)+( 0.660)*r(143)+( 1.000)*r(144)
     &                +( 0.208)*r(162)+( 0.330)*r(165)+( 0.164)*r(167)
     &                +( 0.285)*r(171)+( 0.500)*r(179)+( 0.120)*r(186)
     &                +( 0.266)*r(190)+( 0.567)*r(194)+( 0.246)*r(198)
     &                +( 0.155)*r(205)+( 0.378)*r(209)+( 0.099)*r(215)
c
        Loss(lHONO )= +( 1.000)*r( 22)+( 1.000)*r( 23)+( 1.000)*r( 24)
c
        Gain(lHONO )= +( 1.000)*r( 21)
c
        Loss(lHO2  )= +( 1.000)*r( 31)+( 1.000)*r( 32)+( 1.000)*r( 36)
     &                +( 2.000)*r( 37)+( 2.000)*r( 38)+( 1.000)*r( 39)
     &                +( 1.000)*r( 43)+( 1.000)*r( 47)+( 1.000)*r( 52)
     &                +( 1.000)*r( 57)+( 1.000)*r( 63)+( 1.000)*r( 72)
     &                +( 1.000)*r( 82)+( 1.000)*r( 93)+( 1.000)*r(105)
     &                +( 1.000)*r(118)+( 1.000)*r(121)+( 1.000)*r(126)
c
        Gain(lHO2  )= +( 1.000)*r( 23)+( 1.000)*r( 26)+( 1.000)*r( 29)
     &                +( 1.000)*r( 30)+( 1.000)*r( 33)+( 0.610)*r( 34)
     &                +( 1.000)*r( 42)+( 1.000)*r( 44)+( 1.000)*r( 45)
     &                +( 1.000)*r( 46)+( 1.000)*r( 48)+( 2.000)*r( 50)
     &                +( 1.000)*r( 51)+( 1.000)*r( 53)+( 1.000)*r( 54)
     &                +( 1.000)*r( 55)+( 1.000)*r( 57)+( 1.000)*r( 64)
     &                +( 1.000)*r( 65)+( 1.000)*r( 66)+( 1.000)*r( 68)
     &                +( 2.000)*r(123)+( 1.000)*r(125)+( 1.000)*r(127)
     &                +( 1.000)*r(128)+( 1.000)*r(129)+( 1.000)*r(131)
        Gain(lHO2  ) = Gain(lHO2  )
     &                +( 1.000)*r(134)+( 1.000)*r(140)+( 1.000)*r(142)
     &                +( 1.000)*r(144)+( 2.000)*r(145)+( 0.630)*r(147)
     &                +( 0.630)*r(148)+( 1.000)*r(149)+( 0.008)*r(162)
     &                +( 0.340)*r(165)+( 0.064)*r(167)+( 0.400)*r(171)
     &                +( 1.233)*r(173)+( 0.379)*r(174)+( 0.113)*r(176)
     &                +( 0.341)*r(177)+( 1.500)*r(179)+( 0.500)*r(181)
     &                +( 0.500)*r(183)+( 0.120)*r(186)+( 0.500)*r(188)
     &                +( 0.033)*r(194)+( 0.121)*r(198)+( 0.224)*r(202)
        Gain(lHO2  ) = Gain(lHO2  )
     &                +( 0.187)*r(203)+( 0.056)*r(205)+( 0.003)*r(209)
     &                +( 0.013)*r(211)+( 0.950)*r(212)+( 0.099)*r(215)
c
        Loss(lCO   )= +( 1.000)*r( 29)
c
        Gain(lCO   )= +( 1.000)*r(123)+( 1.000)*r(124)+( 1.000)*r(125)
     &                +( 1.000)*r(129)+( 1.000)*r(131)+( 0.034)*r(133)
     &                +( 1.000)*r(134)+( 2.000)*r(145)+( 1.000)*r(146)
     &                +( 1.260)*r(147)+( 1.260)*r(148)+( 1.000)*r(149)
     &                +( 1.000)*r(150)+( 1.000)*r(151)+( 0.416)*r(161)
     &                +( 0.450)*r(162)+( 0.500)*r(163)+( 0.670)*r(165)
     &                +( 0.475)*r(167)+( 0.700)*r(169)+( 0.336)*r(170)
     &                +( 0.498)*r(171)+( 0.572)*r(172)+( 1.233)*r(173)
     &                +( 1.000)*r(178)+( 1.500)*r(179)+( 1.000)*r(181)
        Gain(lCO   ) = Gain(lCO   )
     &                +( 1.000)*r(183)+( 0.500)*r(186)+( 0.491)*r(188)
     &                +( 0.275)*r(190)+( 0.157)*r(194)+( 0.160)*r(198)
     &                +( 0.002)*r(200)+( 0.345)*r(205)+( 0.265)*r(209)
     &                +( 0.012)*r(211)+( 0.365)*r(215)
c
        Loss(lHNO4 )= +( 1.000)*r( 33)+( 1.000)*r( 34)+( 1.000)*r( 35)
c
        Gain(lHNO4 )= +( 1.000)*r( 32)
c
        Loss(lHO2H )= +( 1.000)*r( 41)+( 1.000)*r( 42)
c
        Gain(lHO2H )= +( 1.000)*r( 37)+( 1.000)*r( 38)
c
        Loss(lSO2  )= +( 1.000)*r( 44)
c
        Gain(lSO2  )= 0.0
c
        Loss(lSULF )= 0.0
c
        Gain(lSULF )= +( 1.000)*r( 44)
c
        Loss(lCXO2 )= +( 1.000)*r( 46)+( 1.000)*r( 47)+( 1.000)*r( 48)
     &                +( 2.000)*r( 49)+( 2.000)*r( 50)+( 1.000)*r( 54)
     &                +( 1.000)*r( 59)+( 1.000)*r( 64)+( 1.000)*r( 74)
     &                +( 1.000)*r( 84)+( 1.000)*r( 95)+( 1.000)*r(107)
c
        Gain(lCXO2 )= +( 1.000)*r( 59)+( 1.000)*r( 71)+( 1.000)*r( 73)
     &                +( 2.000)*r( 78)+( 1.000)*r( 88)+( 1.000)*r( 99)
     &                +( 1.000)*r(111)+( 1.000)*r(116)+( 1.000)*r(131)
     &                +( 1.000)*r(137)+( 0.650)*r(141)+( 0.300)*r(169)
     &                +( 1.000)*r(184)+( 0.300)*r(188)+( 0.250)*r(192)
     &                +( 0.011)*r(200)+( 0.076)*r(205)+( 0.197)*r(209)
     &                +( 0.030)*r(210)+( 0.162)*r(213)
c
        Loss(lHCHO )= +( 1.000)*r(123)+( 1.000)*r(124)+( 1.000)*r(125)
     &                +( 1.000)*r(126)+( 1.000)*r(129)
c
        Gain(lHCHO )= +( 1.000)*r( 46)+( 1.000)*r( 48)+( 1.000)*r( 49)
     &                +( 2.000)*r( 50)+( 0.750)*r( 54)+( 0.750)*r( 64)
     &                +( 1.000)*r( 74)+( 1.000)*r( 84)+( 1.000)*r( 95)
     &                +( 1.000)*r(104)+( 1.000)*r(106)+( 1.000)*r(107)
     &                +( 1.000)*r(111)+( 1.000)*r(112)+( 1.000)*r(113)
     &                +( 2.000)*r(114)+( 1.000)*r(127)+( 1.000)*r(136)
     &                +( 0.115)*r(138)+( 1.000)*r(140)+( 0.350)*r(141)
     &                +( 1.000)*r(142)+( 1.000)*r(146)+( 0.084)*r(161)
     &                +( 0.200)*r(162)+( 0.670)*r(165)+( 0.300)*r(166)
        Gain(lHCHO ) = Gain(lHCHO )
     &                +( 0.100)*r(167)+( 0.055)*r(170)+( 0.125)*r(171)
     &                +( 0.227)*r(172)+( 0.300)*r(173)+( 0.213)*r(174)
     &                +( 0.506)*r(175)+( 0.010)*r(176)+( 0.134)*r(177)
     &                +( 1.610)*r(185)+( 1.000)*r(186)+( 0.191)*r(188)
     &                +( 0.624)*r(189)+( 0.592)*r(190)+( 0.240)*r(192)
     &                +( 0.276)*r(193)+( 0.235)*r(194)+( 0.039)*r(198)
     &                +( 0.026)*r(199)+( 0.024)*r(200)+( 0.026)*r(201)
     &                +( 0.732)*r(204)+( 0.500)*r(205)+( 0.244)*r(208)
        Gain(lHCHO ) = Gain(lHCHO )
     &                +( 0.269)*r(209)+( 0.079)*r(210)+( 0.081)*r(212)
     &                +( 0.234)*r(213)+( 0.311)*r(214)+( 0.300)*r(215)
c
        Loss(lCOOH )= +( 1.000)*r(141)+( 1.000)*r(142)
c
        Gain(lCOOH )= +( 1.000)*r( 47)
c
        Loss(lMEOH )= +( 1.000)*r(140)
c
        Gain(lMEOH )= +( 1.000)*r( 49)+( 0.250)*r( 54)+( 0.250)*r( 64)
c
        Loss(lRO2R )= +( 1.000)*r( 51)+( 1.000)*r( 52)+( 1.000)*r( 53)
     &                +( 1.000)*r( 54)+( 2.000)*r( 55)+( 1.000)*r( 60)
     &                +( 1.000)*r( 66)+( 1.000)*r( 75)+( 1.000)*r( 85)
     &                +( 1.000)*r( 96)+( 1.000)*r(108)
c
        Gain(lRO2R )= +( 1.000)*r( 60)+( 1.000)*r( 81)+( 1.000)*r( 83)
     &                +( 1.000)*r( 88)+( 2.000)*r( 89)+( 1.000)*r(100)
     &                +( 1.000)*r(112)+( 0.034)*r(133)+( 1.000)*r(134)
     &                +( 0.370)*r(138)+( 1.000)*r(139)+( 0.340)*r(143)
     &                +( 0.760)*r(153)+( 0.760)*r(155)+( 0.500)*r(161)
     &                +( 0.100)*r(162)+( 0.500)*r(163)+( 0.330)*r(165)
     &                +( 0.300)*r(166)+( 0.050)*r(167)+( 0.670)*r(170)
     &                +( 0.048)*r(171)+( 0.799)*r(172)+( 0.473)*r(174)
     &                +( 0.960)*r(175)+( 0.376)*r(176)+( 0.564)*r(177)
        Gain(lRO2R ) = Gain(lRO2R )
     &                +( 1.000)*r(178)+( 1.000)*r(181)+( 1.000)*r(183)
     &                +( 1.000)*r(185)+( 1.000)*r(187)+( 0.200)*r(188)
     &                +( 0.907)*r(189)+( 0.066)*r(190)+( 0.749)*r(191)
     &                +( 0.750)*r(193)+( 0.031)*r(194)+( 0.276)*r(195)
     &                +( 1.000)*r(197)+( 0.612)*r(198)+( 0.695)*r(199)
     &                +( 0.835)*r(200)+( 0.653)*r(201)+( 0.765)*r(202)
     &                +( 0.804)*r(203)+( 0.910)*r(204)+( 0.022)*r(205)
     &                +( 0.824)*r(206)+( 0.918)*r(208)+( 0.033)*r(209)
        Gain(lRO2R ) = Gain(lRO2R )
     &                +( 0.442)*r(210)+( 0.012)*r(211)+( 0.050)*r(212)
     &                +( 0.743)*r(213)+( 0.935)*r(214)+( 0.935)*r(216)
c
        Loss(lROOH )= +( 1.000)*r(143)+( 1.000)*r(144)
c
        Gain(lROOH )= +( 1.000)*r( 52)+( 1.000)*r( 63)
c
        Loss(lR2O2 )= +( 1.000)*r( 56)+( 1.000)*r( 57)+( 1.000)*r( 58)
     &                +( 1.000)*r( 59)+( 1.000)*r( 60)+( 2.000)*r( 61)
     &                +( 1.000)*r( 67)+( 1.000)*r( 76)+( 1.000)*r( 86)
     &                +( 1.000)*r( 97)+( 1.000)*r(109)
c
        Gain(lR2O2 )= +( 1.000)*r( 92)+( 1.000)*r( 94)+( 1.000)*r( 99)
     &                +( 1.000)*r(100)+( 2.000)*r(101)+( 1.000)*r(113)
     &                +( 1.000)*r(136)+( 0.616)*r(138)+( 0.675)*r(166)
     &                +( 0.515)*r(175)+( 0.596)*r(176)+( 0.152)*r(177)
     &                +( 1.000)*r(180)+( 1.000)*r(181)+( 1.000)*r(182)
     &                +( 1.000)*r(183)+( 0.079)*r(189)+( 0.126)*r(190)
     &                +( 0.187)*r(191)+( 0.240)*r(192)+( 0.500)*r(193)
     &                +( 0.729)*r(194)+( 0.750)*r(195)+( 0.559)*r(199)
     &                +( 0.936)*r(200)+( 0.948)*r(201)+( 0.205)*r(204)
        Gain(lR2O2 ) = Gain(lR2O2 )
     &                +( 0.488)*r(206)+( 0.001)*r(208)+( 0.137)*r(209)
     &                +( 0.711)*r(210)+( 0.381)*r(213)
c
        Loss(lRO2N )= +( 1.000)*r( 62)+( 1.000)*r( 63)+( 1.000)*r( 64)
     &                +( 1.000)*r( 65)+( 1.000)*r( 66)+( 1.000)*r( 67)
     &                +( 2.000)*r( 68)+( 1.000)*r( 77)+( 1.000)*r( 87)
     &                +( 1.000)*r( 98)+( 1.000)*r(110)
c
        Gain(lRO2N )= +( 1.000)*r( 67)+( 0.001)*r(133)+( 0.042)*r(138)
     &                +( 0.025)*r(166)+( 0.041)*r(170)+( 0.051)*r(172)
     &                +( 0.070)*r(174)+( 0.040)*r(175)+( 0.173)*r(176)
     &                +( 0.095)*r(177)+( 0.093)*r(189)+( 0.008)*r(190)
     &                +( 0.064)*r(191)+( 0.010)*r(192)+( 0.250)*r(193)
     &                +( 0.180)*r(194)+( 0.250)*r(195)+( 0.021)*r(198)
     &                +( 0.070)*r(199)+( 0.143)*r(200)+( 0.347)*r(201)
     &                +( 0.011)*r(202)+( 0.009)*r(203)+( 0.090)*r(204)
     &                +( 0.001)*r(205)+( 0.176)*r(206)+( 0.082)*r(208)
        Gain(lRO2N ) = Gain(lRO2N )
     &                +( 0.002)*r(209)+( 0.136)*r(210)+( 0.001)*r(211)
     &                +( 0.078)*r(213)+( 0.065)*r(214)+( 0.065)*r(216)
c
        Loss(lRNO3 )= +( 1.000)*r(176)+( 1.000)*r(177)
c
        Gain(lRNO3 )= +( 1.000)*r( 62)+( 1.000)*r(115)+( 0.572)*r(172)
     &                +( 0.310)*r(176)+( 0.813)*r(191)+( 0.276)*r(195)
     &                +( 0.511)*r(206)+( 0.321)*r(210)+( 1.000)*r(216)
c
        Loss(lMEK  )= +( 1.000)*r(138)+( 1.000)*r(139)
c
        Gain(lMEK  )= +( 0.500)*r( 64)+( 1.000)*r( 65)+( 0.500)*r( 66)
     &                +( 1.000)*r( 68)+( 0.416)*r(161)+( 0.550)*r(168)
     &                +( 0.150)*r(170)+( 0.210)*r(171)+( 0.233)*r(173)
     &                +( 0.115)*r(174)+( 0.177)*r(176)+( 0.243)*r(177)
     &                +( 0.332)*r(199)+( 0.110)*r(200)+( 0.089)*r(201)
     &                +( 0.437)*r(207)+( 0.072)*r(208)+( 0.026)*r(209)
     &                +( 0.001)*r(210)+( 0.659)*r(211)+( 0.719)*r(213)
     &                +( 0.550)*r(217)
c
        Loss(lPROD )= +( 1.000)*r(174)+( 1.000)*r(175)
c
        Gain(lPROD )= +( 0.500)*r( 64)+( 0.500)*r( 66)+( 1.000)*r( 68)
     &                +( 1.000)*r( 77)+( 1.000)*r( 87)+( 1.000)*r( 98)
     &                +( 0.700)*r(169)+( 0.332)*r(170)+( 0.329)*r(174)
     &                +( 0.048)*r(176)+( 0.435)*r(177)+( 0.100)*r(190)
     &                +( 0.750)*r(192)+( 0.276)*r(193)+( 0.276)*r(194)
     &                +( 0.853)*r(196)+( 0.125)*r(200)+( 0.417)*r(201)
     &                +( 0.055)*r(202)+( 0.119)*r(204)+( 0.215)*r(205)
     &                +( 0.113)*r(207)+( 0.006)*r(209)+( 0.259)*r(211)
     &                +( 0.007)*r(213)
c
        Loss(lCCO3 )= +( 1.000)*r( 69)+( 1.000)*r( 71)+( 1.000)*r( 72)
     &                +( 1.000)*r( 73)+( 1.000)*r( 74)+( 1.000)*r( 75)
     &                +( 1.000)*r( 76)+( 1.000)*r( 77)+( 2.000)*r( 78)
     &                +( 1.000)*r( 88)+( 1.000)*r( 99)+( 1.000)*r(111)
c
        Gain(lCCO3 )= +( 1.000)*r( 70)+( 1.000)*r( 76)+( 1.000)*r(104)
     &                +( 1.000)*r(106)+( 1.000)*r(111)+( 1.000)*r(112)
     &                +( 1.000)*r(113)+( 2.000)*r(114)+( 1.000)*r(130)
     &                +( 1.000)*r(132)+( 1.000)*r(136)+( 1.000)*r(137)
     &                +( 0.492)*r(138)+( 1.000)*r(139)+( 1.000)*r(149)
     &                +( 1.000)*r(150)+( 1.000)*r(151)+( 2.000)*r(152)
     &                +( 0.670)*r(165)+( 0.675)*r(166)+( 0.467)*r(173)
     &                +( 0.029)*r(174)+( 0.667)*r(175)+( 1.000)*r(180)
     &                +( 0.500)*r(181)+( 1.000)*r(182)+( 0.500)*r(183)
        Gain(lCCO3 ) = Gain(lCCO3 )
     &                +( 0.123)*r(194)+( 0.011)*r(200)+( 0.137)*r(209)
c
        Loss(lPAN  )= +( 1.000)*r( 70)
c
        Gain(lPAN  )= +( 1.000)*r( 69)
c
        Loss(lCO3H )= 0.0
c
        Gain(lCO3H )= +( 0.750)*r( 72)
c
        Loss(lCO2H )= 0.0
c
        Gain(lCO2H )= +( 0.250)*r( 72)+( 1.000)*r( 74)+( 1.000)*r( 75)
     &                +( 1.000)*r( 77)+( 0.050)*r(205)+( 0.129)*r(209)
c
        Loss(lRCO3 )= +( 1.000)*r( 79)+( 1.000)*r( 81)+( 1.000)*r( 82)
     &                +( 1.000)*r( 83)+( 1.000)*r( 84)+( 1.000)*r( 85)
     &                +( 1.000)*r( 86)+( 1.000)*r( 87)+( 1.000)*r( 88)
     &                +( 2.000)*r( 89)+( 1.000)*r(100)+( 1.000)*r(112)
c
        Gain(lRCO3 )= +( 1.000)*r( 80)+( 1.000)*r( 86)+( 0.965)*r(133)
     &                +( 1.000)*r(135)+( 0.096)*r(138)+( 0.370)*r(147)
     &                +( 0.370)*r(148)+( 0.100)*r(162)+( 0.050)*r(167)
     &                +( 0.048)*r(171)+( 0.300)*r(173)+( 0.049)*r(174)
     &                +( 0.333)*r(175)+( 0.201)*r(194)+( 0.006)*r(209)
c
        Loss(lPAN2 )= +( 1.000)*r( 80)
c
        Gain(lPAN2 )= +( 1.000)*r( 79)
c
        Loss(lCCHO )= +( 1.000)*r(130)+( 1.000)*r(131)+( 1.000)*r(132)
c
        Gain(lCCHO )= +( 1.000)*r( 81)+( 1.000)*r( 83)+( 1.000)*r( 88)
     &                +( 2.000)*r( 89)+( 1.000)*r(100)+( 1.000)*r(112)
     &                +( 0.034)*r(133)+( 1.000)*r(134)+( 0.482)*r(138)
     &                +( 1.000)*r(139)+( 0.129)*r(170)+( 0.047)*r(171)
     &                +( 0.467)*r(173)+( 0.084)*r(174)+( 0.246)*r(175)
     &                +( 0.439)*r(176)+( 0.431)*r(177)+( 0.195)*r(185)
     &                +( 0.250)*r(188)+( 1.000)*r(197)+( 0.445)*r(199)
     &                +( 0.455)*r(200)+( 0.099)*r(201)+( 0.294)*r(204)
     &                +( 0.154)*r(205)+( 0.009)*r(206)+( 0.732)*r(208)
        Gain(lCCHO ) = Gain(lCCHO )
     &                +( 0.456)*r(209)+( 0.507)*r(210)+( 0.960)*r(212)
     &                +( 0.624)*r(214)
c
        Loss(lRC3H )= 0.0
c
        Gain(lRC3H )= +( 0.750)*r( 82)+( 0.750)*r( 93)+( 0.750)*r(105)
c
        Loss(lRC2H )= 0.0
c
        Gain(lRC2H )= +( 0.250)*r( 82)+( 1.000)*r( 84)+( 1.000)*r( 85)
     &                +( 1.000)*r( 87)+( 0.250)*r( 93)+( 1.000)*r( 95)
     &                +( 1.000)*r( 96)+( 1.000)*r( 98)+( 0.250)*r(105)
     &                +( 1.000)*r(107)+( 1.000)*r(108)+( 2.000)*r(110)
     &                +( 0.372)*r(171)+( 0.150)*r(190)+( 0.189)*r(194)
     &                +( 0.119)*r(205)+( 0.303)*r(209)+( 0.285)*r(215)
c
        Loss(lBZCO )= +( 1.000)*r( 90)+( 1.000)*r( 92)+( 1.000)*r( 93)
     &                +( 1.000)*r( 94)+( 1.000)*r( 95)+( 1.000)*r( 96)
     &                +( 1.000)*r( 97)+( 1.000)*r( 98)+( 1.000)*r( 99)
     &                +( 1.000)*r(100)+( 2.000)*r(101)+( 1.000)*r(113)
c
        Gain(lBZCO )= +( 1.000)*r( 91)+( 1.000)*r( 97)+( 1.000)*r(158)
     &                +( 1.000)*r(160)
c
        Loss(lPBZN )= +( 1.000)*r( 91)
c
        Gain(lPBZN )= +( 1.000)*r( 90)
c
        Loss(lBZO  )= +( 1.000)*r(117)+( 1.000)*r(118)+( 1.000)*r(119)
c
        Gain(lBZO  )= +( 1.000)*r( 92)+( 1.000)*r( 94)+( 1.000)*r( 99)
     &                +( 1.000)*r(100)+( 2.000)*r(101)+( 1.000)*r(113)
     &                +( 0.240)*r(153)+( 1.000)*r(154)+( 0.240)*r(155)
     &                +( 1.000)*r(156)
c
        Loss(lMCO3 )= +( 1.000)*r(102)+( 1.000)*r(104)+( 1.000)*r(105)
     &                +( 1.000)*r(106)+( 1.000)*r(107)+( 1.000)*r(108)
     &                +( 1.000)*r(109)+( 1.000)*r(110)+( 1.000)*r(111)
     &                +( 1.000)*r(112)+( 1.000)*r(113)+( 2.000)*r(114)
c
        Gain(lMCO3 )= +( 1.000)*r(103)+( 1.000)*r(109)+( 0.500)*r(161)
     &                +( 0.500)*r(163)+( 0.330)*r(165)+( 0.300)*r(169)
     &                +( 0.289)*r(170)+( 0.150)*r(172)+( 0.192)*r(190)
     &                +( 0.240)*r(192)
c
        Loss(lMPAN )= +( 1.000)*r(103)
c
        Gain(lMPAN )= +( 1.000)*r(102)
c
        Loss(lTBUO )= +( 1.000)*r(115)+( 1.000)*r(116)
c
        Gain(lTBUO )= +( 0.236)*r(199)+( 0.016)*r(213)
c
        Loss(lACET )= +( 1.000)*r(136)+( 1.000)*r(137)
c
        Gain(lACET )= +( 1.000)*r(116)+( 0.006)*r(176)+( 0.020)*r(177)
     &                +( 0.130)*r(194)+( 0.417)*r(198)+( 0.024)*r(199)
     &                +( 0.452)*r(200)+( 0.072)*r(201)+( 0.005)*r(204)
     &                +( 0.001)*r(205)+( 0.024)*r(206)+( 0.127)*r(208)
     &                +( 0.045)*r(209)+( 0.102)*r(210)+( 0.024)*r(213)
     &                +( 0.624)*r(214)+( 0.015)*r(215)+( 0.934)*r(216)
c
        Loss(lNPHE )= +( 1.000)*r(157)
c
        Gain(lNPHE )= +( 1.000)*r(117)+( 1.000)*r(121)+( 1.000)*r(122)
c
        Loss(lPHEN )= +( 1.000)*r(153)+( 1.000)*r(154)
c
        Gain(lPHEN )= +( 1.000)*r(118)+( 1.000)*r(119)+( 0.017)*r(202)
c
        Loss(lBZNO )= +( 1.000)*r(120)+( 1.000)*r(121)+( 1.000)*r(122)
c
        Gain(lBZNO )= +( 1.000)*r(157)
c
        Loss(lXN   )= 0.0
c
        Gain(lXN   )= +( 2.000)*r(120)+( 0.500)*r(163)+( 0.278)*r(172)
     &                +( 0.352)*r(176)+( 1.000)*r(187)+( 0.250)*r(195)
     &                +( 0.489)*r(206)+( 0.288)*r(210)
c
        Loss(lHCO3 )= +( 1.000)*r(127)+( 1.000)*r(128)
c
        Gain(lHCO3 )= +( 1.000)*r(126)
c
        Loss(lHC2H )= 0.0
c
        Gain(lHC2H )= +( 1.000)*r(128)+( 0.333)*r(162)+( 0.351)*r(167)
     &                +( 0.100)*r(171)+( 0.370)*r(186)+( 0.204)*r(190)
     &                +( 0.103)*r(194)+( 0.121)*r(198)+( 0.185)*r(205)
     &                +( 0.073)*r(209)+( 0.259)*r(215)
c
        Loss(lRCHO )= +( 1.000)*r(133)+( 1.000)*r(134)+( 1.000)*r(135)
c
        Gain(lRCHO )= +( 0.370)*r(138)+( 1.000)*r(143)+( 1.000)*r(144)
     &                +( 1.000)*r(164)+( 0.675)*r(166)+( 0.450)*r(168)
     &                +( 0.013)*r(170)+( 0.218)*r(172)+( 0.558)*r(174)
     &                +( 0.710)*r(175)+( 0.213)*r(176)+( 0.147)*r(177)
     &                +( 1.000)*r(178)+( 1.000)*r(180)+( 1.000)*r(182)
     &                +( 1.000)*r(187)+( 0.474)*r(193)+( 0.205)*r(194)
     &                +( 0.474)*r(195)+( 0.147)*r(196)+( 0.155)*r(198)
     &                +( 0.122)*r(199)+( 0.244)*r(200)+( 0.204)*r(201)
     &                +( 0.497)*r(204)+( 0.363)*r(205)+( 0.037)*r(206)
        Gain(lRCHO ) = Gain(lRCHO )
     &                +( 0.450)*r(207)+( 0.511)*r(208)+( 0.305)*r(209)
     &                +( 0.151)*r(210)+( 0.069)*r(211)+( 0.311)*r(214)
     &                +( 0.700)*r(215)+( 0.935)*r(216)+( 0.450)*r(217)
c
        Loss(lGLY  )= +( 1.000)*r(145)+( 1.000)*r(146)+( 1.000)*r(147)
     &                +( 1.000)*r(148)
c
        Gain(lGLY  )= +( 0.230)*r(153)+( 0.150)*r(170)+( 0.023)*r(171)
     &                +( 1.000)*r(179)+( 0.500)*r(181)+( 0.500)*r(183)
     &                +( 0.009)*r(188)+( 0.001)*r(194)+( 0.248)*r(198)
     &                +( 0.118)*r(202)+( 0.097)*r(203)
c
        Loss(lMGLY )= +( 1.000)*r(149)+( 1.000)*r(150)+( 1.000)*r(151)
c
        Gain(lMGLY )= +( 0.230)*r(155)+( 0.084)*r(161)+( 0.900)*r(162)
     &                +( 0.300)*r(166)+( 0.950)*r(167)+( 0.174)*r(170)
     &                +( 0.742)*r(171)+( 0.008)*r(172)+( 0.500)*r(181)
     &                +( 0.500)*r(183)+( 0.119)*r(202)+( 0.287)*r(203)
c
        Loss(lBACL )= +( 1.000)*r(152)
c
        Gain(lBACL )= +( 0.031)*r(194)+( 0.087)*r(203)
c
        Loss(lCRES )= +( 1.000)*r(155)+( 1.000)*r(156)
c
        Gain(lCRES )= +( 0.207)*r(202)+( 0.187)*r(203)
c
        Loss(lBALD )= +( 1.000)*r(158)+( 1.000)*r(159)+( 1.000)*r(160)
c
        Gain(lBALD )= +( 0.059)*r(202)+( 0.050)*r(203)+( 0.061)*r(208)
     &                +( 0.042)*r(209)+( 0.015)*r(210)
c
        Loss(lMETH )= +( 1.000)*r(161)+( 1.000)*r(162)+( 1.000)*r(163)
     &                +( 1.000)*r(164)+( 1.000)*r(165)
c
        Gain(lMETH )= +( 0.230)*r(189)+( 0.390)*r(190)+( 0.025)*r(208)
     &                +( 0.026)*r(209)+( 0.012)*r(211)
c
        Loss(lMVK  )= +( 1.000)*r(166)+( 1.000)*r(167)+( 1.000)*r(168)
     &                +( 1.000)*r(169)
c
        Gain(lMVK  )= +( 0.320)*r(189)+( 0.160)*r(190)+( 0.048)*r(210)
c
        Loss(lISPD )= +( 1.000)*r(170)+( 1.000)*r(171)+( 1.000)*r(172)
     &                +( 1.000)*r(173)
c
        Gain(lISPD )= +( 0.357)*r(189)+( 0.936)*r(191)+( 0.025)*r(208)
c
        Loss(lDCB1 )= +( 1.000)*r(178)+( 1.000)*r(179)
c
        Gain(lDCB1 )= +( 0.491)*r(202)+( 0.561)*r(203)
c
        Loss(lDCB2 )= +( 1.000)*r(180)+( 1.000)*r(181)
c
        Gain(lDCB2 )= +( 0.108)*r(202)+( 0.099)*r(203)
c
        Loss(lDCB3 )= +( 1.000)*r(182)+( 1.000)*r(183)
c
        Gain(lDCB3 )= +( 0.051)*r(202)+( 0.093)*r(203)
c
        Loss(lETHE )= +( 1.000)*r(185)+( 1.000)*r(186)+( 1.000)*r(187)
     &                +( 1.000)*r(188)
c
        Gain(lETHE )= 0.0
c
        Loss(lISOP )= +( 1.000)*r(189)+( 1.000)*r(190)+( 1.000)*r(191)
     &                +( 1.000)*r(192)
c
        Gain(lISOP )= 0.0
c
        Loss(lTERP )= +( 1.000)*r(193)+( 1.000)*r(194)+( 1.000)*r(195)
     &                +( 1.000)*r(196)
c
        Gain(lTERP )= 0.0
c
        Loss(lALK1 )= +( 1.000)*r(197)
c
        Gain(lALK1 )= 0.0
c
        Loss(lALK2 )= +( 1.000)*r(198)
c
        Gain(lALK2 )= 0.0
c
        Loss(lALK3 )= +( 1.000)*r(199)
c
        Gain(lALK3 )= 0.0
c
        Loss(lALK4 )= +( 1.000)*r(200)
c
        Gain(lALK4 )= 0.0
c
        Loss(lALK5 )= +( 1.000)*r(201)
c
        Gain(lALK5 )= 0.0
c
        Loss(lARO1 )= +( 1.000)*r(202)
c
        Gain(lARO1 )= 0.0
c
        Loss(lARO2 )= +( 1.000)*r(203)
c
        Gain(lARO2 )= 0.0
c
        Loss(lOLE1 )= +( 1.000)*r(204)+( 1.000)*r(205)+( 1.000)*r(206)
     &                +( 1.000)*r(207)
c
        Gain(lOLE1 )= 0.0
c
        Loss(lOLE2 )= +( 1.000)*r(208)+( 1.000)*r(209)+( 1.000)*r(210)
     &                +( 1.000)*r(211)
c
        Gain(lOLE2 )= 0.0
c
        Loss(lETOH )= +( 1.000)*r(212)
c
        Gain(lETOH )= 0.0
c
        Loss(lMTBE )= +( 1.000)*r(213)
c
        Gain(lMTBE )= 0.0
c
        Loss(lMBUT )= +( 1.000)*r(214)+( 1.000)*r(215)+( 1.000)*r(216)
     &                +( 1.000)*r(217)
c
        Gain(lMBUT )= 0.0
c
c
      return
      end

      subroutine ebirxn5(ny,nr,yh,H2O,M,O2,CH4,H2,rk,r)
c
c----CAMx v4.53 090209
c
c     EBIRXN5 computes reaction rates for the EBI solver
c
c     Copyright 1996-2009
c     ENVIRON International Corporation
c     Created by the CMC version 5
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        ny  - dimension of y
c        nr  - dimension of r and rk
c        yh  - current y (ppm)
c        H2O - water vapor Concentration (ppm)
c        M   - total gas Concentration (ppm)
c        O2  - oxygen Concentration (ppm)
c        CH4 - methane Concentration (ppm)
c        H2  - hydrogen Concentration (ppm)
c        rk  - rate constants (units ppm hr)
c        r   - reaction rates (hr-1)
c
c --- Includes:
      implicit none
      include "camx.prm"
      include "ddmchm.com"
c
c --- Arguments:
      integer ny, nr
      real    yh(ny+1)
      real    r(nr), rk(nr)
      real    H2O,M,O2,CH4,H2
c
c --- Local variables:
      real    N2
c
c --- Entry point
c
      N2  = M - O2
c
c --- Calculate reaction rates
c
      r(  1) = rk(  1)*yh(lNO2)
      r(  2) = rk(  2)*yh(lO)*O2*M
      r(  3) = rk(  3)*yh(lO)*yh(lO3)
      r(  4) = rk(  4)*yh(lO)*yh(lNO)*M
      r(  5) = rk(  5)*yh(lO)*yh(lNO2)
      r(  6) = rk(  6)*yh(lO)*yh(lNO2)
      r(  7) = rk(  7)*yh(lO3)*yh(lNO)
      r(  8) = rk(  8)*yh(lO3)*yh(lNO2)
      r(  9) = rk(  9)*yh(lNO)*yh(lNO3)
      r( 10) = rk( 10)*yh(lNO)*yh(lNO)*O2
      r( 11) = rk( 11)*yh(lNO2)*yh(lNO3)
      r( 12) = rk( 12)*yh(lN2O5)
      r( 13) = rk( 13)*yh(lN2O5)*H2O
      r( 14) = rk( 14)*yh(lNO2)*yh(lNO3)
      r( 15) = rk( 15)*yh(lNO3)
      r( 16) = rk( 16)*yh(lNO3)
      r( 17) = rk( 17)*yh(lO3)
      r( 18) = rk( 18)*yh(lO3)
      r( 19) = rk( 19)*yh(lO1D)*H2O
      r( 20) = rk( 20)*yh(lO1D)*M
      r( 21) = rk( 21)*yh(lOH)*yh(lNO)
      r( 22) = rk( 22)*yh(lHONO)
      r( 23) = rk( 23)*yh(lHONO)
      r( 24) = rk( 24)*yh(lOH)*yh(lHONO)
      r( 25) = rk( 25)*yh(lOH)*yh(lNO2)
      r( 26) = rk( 26)*yh(lOH)*yh(lNO3)
      r( 27) = rk( 27)*yh(lOH)*yh(lHNO3)
      r( 28) = rk( 28)*yh(lHNO3)
      r( 29) = rk( 29)*yh(lOH)*yh(lCO)
      r( 30) = rk( 30)*yh(lOH)*yh(lO3)
      r( 31) = rk( 31)*yh(lHO2)*yh(lNO)
      r( 32) = rk( 32)*yh(lHO2)*yh(lNO2)
      r( 33) = rk( 33)*yh(lHNO4)
      r( 34) = rk( 34)*yh(lHNO4)
      r( 35) = rk( 35)*yh(lHNO4)*yh(lOH)
      r( 36) = rk( 36)*yh(lHO2)*yh(lO3)
      r( 37) = rk( 37)*yh(lHO2)*yh(lHO2)
      r( 38) = rk( 38)*yh(lHO2)*yh(lHO2)*H2O
      r( 39) = rk( 39)*yh(lNO3)*yh(lHO2)
      r( 40) = rk( 40)*yh(lNO3)*yh(lNO3)
      r( 41) = rk( 41)*yh(lHO2H)
      r( 42) = rk( 42)*yh(lHO2H)*yh(lOH)
      r( 43) = rk( 43)*yh(lOH)*yh(lHO2)
      r( 44) = rk( 44)*yh(lOH)*yh(lSO2)
      r( 45) = rk( 45)*yh(lOH)*H2
      r( 46) = rk( 46)*yh(lCXO2)*yh(lNO)
      r( 47) = rk( 47)*yh(lCXO2)*yh(lHO2)
      r( 48) = rk( 48)*yh(lCXO2)*yh(lNO3)
      r( 49) = rk( 49)*yh(lCXO2)*yh(lCXO2)
      r( 50) = rk( 50)*yh(lCXO2)*yh(lCXO2)
      r( 51) = rk( 51)*yh(lRO2R)*yh(lNO)
      r( 52) = rk( 52)*yh(lRO2R)*yh(lHO2)
      r( 53) = rk( 53)*yh(lRO2R)*yh(lNO3)
      r( 54) = rk( 54)*yh(lRO2R)*yh(lCXO2)
      r( 55) = rk( 55)*yh(lRO2R)*yh(lRO2R)
      r( 56) = rk( 56)*yh(lR2O2)*yh(lNO)
      r( 57) = rk( 57)*yh(lR2O2)*yh(lHO2)
      r( 58) = rk( 58)*yh(lR2O2)*yh(lNO3)
      r( 59) = rk( 59)*yh(lR2O2)*yh(lCXO2)
      r( 60) = rk( 60)*yh(lR2O2)*yh(lRO2R)
      r( 61) = rk( 61)*yh(lR2O2)*yh(lR2O2)
      r( 62) = rk( 62)*yh(lRO2N)*yh(lNO)
      r( 63) = rk( 63)*yh(lRO2N)*yh(lHO2)
      r( 64) = rk( 64)*yh(lRO2N)*yh(lCXO2)
      r( 65) = rk( 65)*yh(lRO2N)*yh(lNO3)
      r( 66) = rk( 66)*yh(lRO2N)*yh(lRO2R)
      r( 67) = rk( 67)*yh(lRO2N)*yh(lR2O2)
      r( 68) = rk( 68)*yh(lRO2N)*yh(lRO2N)
      r( 69) = rk( 69)*yh(lCCO3)*yh(lNO2)
      r( 70) = rk( 70)*yh(lPAN)
      r( 71) = rk( 71)*yh(lCCO3)*yh(lNO)
      r( 72) = rk( 72)*yh(lCCO3)*yh(lHO2)
      r( 73) = rk( 73)*yh(lCCO3)*yh(lNO3)
      r( 74) = rk( 74)*yh(lCCO3)*yh(lCXO2)
      r( 75) = rk( 75)*yh(lCCO3)*yh(lRO2R)
      r( 76) = rk( 76)*yh(lCCO3)*yh(lR2O2)
      r( 77) = rk( 77)*yh(lCCO3)*yh(lRO2N)
      r( 78) = rk( 78)*yh(lCCO3)*yh(lCCO3)
      r( 79) = rk( 79)*yh(lRCO3)*yh(lNO2)
      r( 80) = rk( 80)*yh(lPAN2)
      r( 81) = rk( 81)*yh(lRCO3)*yh(lNO)
      r( 82) = rk( 82)*yh(lRCO3)*yh(lHO2)
      r( 83) = rk( 83)*yh(lRCO3)*yh(lNO3)
      r( 84) = rk( 84)*yh(lRCO3)*yh(lCXO2)
      r( 85) = rk( 85)*yh(lRCO3)*yh(lRO2R)
      r( 86) = rk( 86)*yh(lRCO3)*yh(lR2O2)
      r( 87) = rk( 87)*yh(lRCO3)*yh(lRO2N)
      r( 88) = rk( 88)*yh(lRCO3)*yh(lCCO3)
      r( 89) = rk( 89)*yh(lRCO3)*yh(lRCO3)
      r( 90) = rk( 90)*yh(lBZCO)*yh(lNO2)
      r( 91) = rk( 91)*yh(lPBZN)
      r( 92) = rk( 92)*yh(lBZCO)*yh(lNO)
      r( 93) = rk( 93)*yh(lBZCO)*yh(lHO2)
      r( 94) = rk( 94)*yh(lBZCO)*yh(lNO3)
      r( 95) = rk( 95)*yh(lBZCO)*yh(lCXO2)
      r( 96) = rk( 96)*yh(lBZCO)*yh(lRO2R)
      r( 97) = rk( 97)*yh(lBZCO)*yh(lR2O2)
      r( 98) = rk( 98)*yh(lBZCO)*yh(lRO2N)
      r( 99) = rk( 99)*yh(lBZCO)*yh(lCCO3)
      r(100) = rk(100)*yh(lBZCO)*yh(lRCO3)
      r(101) = rk(101)*yh(lBZCO)*yh(lBZCO)
      r(102) = rk(102)*yh(lMCO3)*yh(lNO2)
      r(103) = rk(103)*yh(lMPAN)
      r(104) = rk(104)*yh(lMCO3)*yh(lNO)
      r(105) = rk(105)*yh(lMCO3)*yh(lHO2)
      r(106) = rk(106)*yh(lMCO3)*yh(lNO3)
      r(107) = rk(107)*yh(lMCO3)*yh(lCXO2)
      r(108) = rk(108)*yh(lMCO3)*yh(lRO2R)
      r(109) = rk(109)*yh(lMCO3)*yh(lR2O2)
      r(110) = rk(110)*yh(lMCO3)*yh(lRO2N)
      r(111) = rk(111)*yh(lMCO3)*yh(lCCO3)
      r(112) = rk(112)*yh(lMCO3)*yh(lRCO3)
      r(113) = rk(113)*yh(lMCO3)*yh(lBZCO)
      r(114) = rk(114)*yh(lMCO3)*yh(lMCO3)
      r(115) = rk(115)*yh(lTBUO)*yh(lNO2)
      r(116) = rk(116)*yh(lTBUO)
      r(117) = rk(117)*yh(lBZO)*yh(lNO2)
      r(118) = rk(118)*yh(lBZO)*yh(lHO2)
      r(119) = rk(119)*yh(lBZO)
      r(120) = rk(120)*yh(lBZNO)*yh(lNO2)
      r(121) = rk(121)*yh(lBZNO)*yh(lHO2)
      r(122) = rk(122)*yh(lBZNO)
      r(123) = rk(123)*yh(lHCHO)
      r(124) = rk(124)*yh(lHCHO)
      r(125) = rk(125)*yh(lHCHO)*yh(lOH)
      r(126) = rk(126)*yh(lHCHO)*yh(lHO2)
      r(127) = rk(127)*yh(lHCO3)
      r(128) = rk(128)*yh(lHCO3)*yh(lNO)
      r(129) = rk(129)*yh(lHCHO)*yh(lNO3)
      r(130) = rk(130)*yh(lCCHO)*yh(lOH)
      r(131) = rk(131)*yh(lCCHO)
      r(132) = rk(132)*yh(lCCHO)*yh(lNO3)
      r(133) = rk(133)*yh(lRCHO)*yh(lOH)
      r(134) = rk(134)*yh(lRCHO)
      r(135) = rk(135)*yh(lRCHO)*yh(lNO3)
      r(136) = rk(136)*yh(lACET)*yh(lOH)
      r(137) = rk(137)*yh(lACET)
      r(138) = rk(138)*yh(lMEK)*yh(lOH)
      r(139) = rk(139)*yh(lMEK)
      r(140) = rk(140)*yh(lMEOH)*yh(lOH)
      r(141) = rk(141)*yh(lCOOH)*yh(lOH)
      r(142) = rk(142)*yh(lCOOH)
      r(143) = rk(143)*yh(lROOH)*yh(lOH)
      r(144) = rk(144)*yh(lROOH)
      r(145) = rk(145)*yh(lGLY)
      r(146) = rk(146)*yh(lGLY)
      r(147) = rk(147)*yh(lGLY)*yh(lOH)
      r(148) = rk(148)*yh(lGLY)*yh(lNO3)
      r(149) = rk(149)*yh(lMGLY)
      r(150) = rk(150)*yh(lMGLY)*yh(lOH)
      r(151) = rk(151)*yh(lMGLY)*yh(lNO3)
      r(152) = rk(152)*yh(lBACL)
      r(153) = rk(153)*yh(lPHEN)*yh(lOH)
      r(154) = rk(154)*yh(lPHEN)*yh(lNO3)
      r(155) = rk(155)*yh(lCRES)*yh(lOH)
      r(156) = rk(156)*yh(lCRES)*yh(lNO3)
      r(157) = rk(157)*yh(lNPHE)*yh(lNO3)
      r(158) = rk(158)*yh(lBALD)*yh(lOH)
      r(159) = rk(159)*yh(lBALD)
      r(160) = rk(160)*yh(lBALD)*yh(lNO3)
      r(161) = rk(161)*yh(lMETH)*yh(lOH)
      r(162) = rk(162)*yh(lMETH)*yh(lO3)
      r(163) = rk(163)*yh(lMETH)*yh(lNO3)
      r(164) = rk(164)*yh(lMETH)*yh(lO)
      r(165) = rk(165)*yh(lMETH)
      r(166) = rk(166)*yh(lMVK)*yh(lOH)
      r(167) = rk(167)*yh(lMVK)*yh(lO3)
      r(168) = rk(168)*yh(lMVK)*yh(lO)
      r(169) = rk(169)*yh(lMVK)
      r(170) = rk(170)*yh(lISPD)*yh(lOH)
      r(171) = rk(171)*yh(lISPD)*yh(lO3)
      r(172) = rk(172)*yh(lISPD)*yh(lNO3)
      r(173) = rk(173)*yh(lISPD)
      r(174) = rk(174)*yh(lPROD)*yh(lOH)
      r(175) = rk(175)*yh(lPROD)
      r(176) = rk(176)*yh(lRNO3)*yh(lOH)
      r(177) = rk(177)*yh(lRNO3)
      r(178) = rk(178)*yh(lDCB1)*yh(lOH)
      r(179) = rk(179)*yh(lDCB1)*yh(lO3)
      r(180) = rk(180)*yh(lDCB2)*yh(lOH)
      r(181) = rk(181)*yh(lDCB2)
      r(182) = rk(182)*yh(lDCB3)*yh(lOH)
      r(183) = rk(183)*yh(lDCB3)
      r(184) = rk(184)*CH4*yh(lOH)
      r(185) = rk(185)*yh(lETHE)*yh(lOH)
      r(186) = rk(186)*yh(lETHE)*yh(lO3)
      r(187) = rk(187)*yh(lETHE)*yh(lNO3)
      r(188) = rk(188)*yh(lETHE)*yh(lO)
      r(189) = rk(189)*yh(lISOP)*yh(lOH)
      r(190) = rk(190)*yh(lISOP)*yh(lO3)
      r(191) = rk(191)*yh(lISOP)*yh(lNO3)
      r(192) = rk(192)*yh(lISOP)*yh(lO)
      r(193) = rk(193)*yh(lTERP)*yh(lOH)
      r(194) = rk(194)*yh(lTERP)*yh(lO3)
      r(195) = rk(195)*yh(lTERP)*yh(lNO3)
      r(196) = rk(196)*yh(lTERP)*yh(lO)
      r(197) = rk(197)*yh(lALK1)*yh(lOH)
      r(198) = rk(198)*yh(lALK2)*yh(lOH)
      r(199) = rk(199)*yh(lALK3)*yh(lOH)
      r(200) = rk(200)*yh(lALK4)*yh(lOH)
      r(201) = rk(201)*yh(lALK5)*yh(lOH)
      r(202) = rk(202)*yh(lARO1)*yh(lOH)
      r(203) = rk(203)*yh(lARO2)*yh(lOH)
      r(204) = rk(204)*yh(lOLE1)*yh(lOH)
      r(205) = rk(205)*yh(lOLE1)*yh(lO3)
      r(206) = rk(206)*yh(lOLE1)*yh(lNO3)
      r(207) = rk(207)*yh(lOLE1)*yh(lO)
      r(208) = rk(208)*yh(lOLE2)*yh(lOH)
      r(209) = rk(209)*yh(lOLE2)*yh(lO3)
      r(210) = rk(210)*yh(lOLE2)*yh(lNO3)
      r(211) = rk(211)*yh(lOLE2)*yh(lO)
      r(212) = rk(212)*yh(lETOH)*yh(lOH)
      r(213) = rk(213)*yh(lMTBE)*yh(lOH)
      r(214) = rk(214)*yh(lMBUT)*yh(lOH)
      r(215) = rk(215)*yh(lMBUT)*yh(lO3)
      r(216) = rk(216)*yh(lMBUT)*yh(lNO3)
      r(217) = rk(217)*yh(lMBUT)*yh(lO)
c
      return
      end

      subroutine hr_hox5(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
c
c----CAMx v4.53 090209
c
c     HR_HOX5 solves the HOx family using Hertel's equations
c
c     Copyright 1996-2009
c     ENVIRON International Corporation
c     Created by the CMC version 5
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      implicit none
      include "camx.prm"
      include "ddmchm.com"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real t1, t2, t3, A, B, C, Q
      real newOH, newHO2, newHONO, newPNA
      real lsOH, lsHO2, lsHONO, lsPNA, lsO1D, yldOH, self
      real rOH_HO2, rHO2_OH, rOH_HONO, rHONO_OH, rHO2_PNA, rPNA_HO2
c
c --- Entry Point
c
      N2 = M - O2
c
c --- O1D loss
c
      lsO1D = 
     &       + rk( 19)*H2O
     &       + rk( 20)*M
c
c --- Yield of OH from O1D
c
      yldOH  = ( 
     &         ( 2.000)*rk( 19)*H2O ) / lsO1D
c
c --- Conversion of HONO to OH
c
      rHONO_OH  = dt*(
     &       +          rk( 22) )
c
c --- Conversion of HO2 to OH
c
      rHO2_OH  = dt*(
     &       +          rk( 31)*yh(lNO)
     &       +          rk( 36)*yh(lO3)
     &       + ( 0.800)*rk( 39)*yh(lNO3) )
c
c --- Other OH production terms
c
      newOH = y0(lOH) + dt*(
     &       +          r( 28)
     &       + ( 0.390)*r( 34)
     &       + ( 2.000)*r( 41)
     &       +          r(142)
     &       +          r(144)
     &       + ( 0.208)*r(162)
     &       + ( 0.330)*r(165)
     &       + ( 0.164)*r(167)
     &       + ( 0.285)*r(171)
     &       + ( 0.500)*r(179)
     &       + ( 0.120)*r(186)
     &       + ( 0.266)*r(190)
     &       + ( 0.567)*r(194)
     &       + ( 0.155)*r(205)
     &       + ( 0.378)*r(209)
     &       + ( 0.099)*r(215)
     &       +          r( 18)*yldOH )
c
c --- Conversion of PNA to HO2
c
      rPNA_HO2  = dt*(
     &       +          rk( 33)
     &       + ( 0.610)*rk( 34) )
c
c --- Conversion of OH to HO2
c
      rOH_HO2  = dt*(
     &       +          rk( 26)*yh(lNO3)
     &       +          rk( 29)*yh(lCO)
     &       +          rk( 30)*yh(lO3)
     &       +          rk( 42)*yh(lHO2H)
     &       +          rk( 44)*yh(lSO2)
     &       +          rk( 45)*H2
     &       +          rk(125)*yh(lHCHO)
     &       +          rk(140)*yh(lMEOH)
     &       + ( 0.630)*rk(147)*yh(lGLY)
     &       + ( 0.379)*rk(174)*yh(lPROD)
     &       + ( 0.113)*rk(176)*yh(lRNO3)
     &       + ( 0.121)*rk(198)*yh(lALK2)
     &       + ( 0.224)*rk(202)*yh(lARO1)
     &       + ( 0.187)*rk(203)*yh(lARO2)
     &       + ( 0.950)*rk(212)*yh(lETOH) )
c
c --- Other HO2 production terms
c
      newHO2 = y0(lHO2) + dt*(
     &       +          r( 23)
     &       +          r( 46)
     &       +          r( 48)
     &       + ( 2.000)*r( 50)
     &       +          r( 51)
     &       +          r( 53)
     &       +          r( 54)
     &       +          r( 55)
     &       +          r( 64)
     &       +          r( 65)
     &       +          r( 66)
     &       +          r( 68)
     &       + ( 2.000)*r(123)
     &       +          r(127)
     &       +          r(128)
     &       +          r(129)
     &       +          r(131)
     &       +          r(134)
     &       +          r(142)
     &       +          r(144)
     &       + ( 2.000)*r(145)
     &       + ( 0.630)*r(148)
     &       +          r(149)
     &       + ( 0.008)*r(162)
     &       + ( 0.340)*r(165)
     &       + ( 0.064)*r(167)
     &       + ( 0.400)*r(171)
     &       + ( 1.233)*r(173)
     &       + ( 0.341)*r(177)
     &       + ( 1.500)*r(179)
     &       + ( 0.500)*r(181)
     &       + ( 0.500)*r(183)
     &       + ( 0.120)*r(186)
     &       + ( 0.500)*r(188)
     &       + ( 0.033)*r(194)
     &       + ( 0.056)*r(205)
     &       + ( 0.003)*r(209)
     &       + ( 0.013)*r(211)
     &       + ( 0.099)*r(215) )
c
c
c --- Conversion of OH to HONO
c
      rOH_HONO  = dt*(
     &       +          rk( 21)*yh(lNO) )
c
c --- Other HONO production terms
c
      newHONO = y0(lHONO) 
c
c --- Conversion of HO2 to PNA
c
      rHO2_PNA  = dt*(
     &       +          rk( 32)*yh(lNO2) )
c
c --- Other PNA production terms
c
      newPNA = y0(lHNO4) 
c
c --- Net loss of OH
c
      lsOH = 1.0 + dt*(
     &       +          rk( 21)*yh(lNO)
     &       +          rk( 24)*yh(lHONO)
     &       +          rk( 25)*yh(lNO2)
     &       +          rk( 26)*yh(lNO3)
     &       +          rk( 27)*yh(lHNO3)
     &       +          rk( 29)*yh(lCO)
     &       +          rk( 30)*yh(lO3)
     &       +          rk( 35)*yh(lHNO4)
     &       +          rk( 42)*yh(lHO2H)
     &       +          rk( 43)*yh(lHO2)
     &       +          rk( 44)*yh(lSO2)
     &       +          rk( 45)*H2
     &       +          rk(125)*yh(lHCHO)
     &       +          rk(130)*yh(lCCHO)
     &       +          rk(133)*yh(lRCHO)
     &       +          rk(136)*yh(lACET)
     &       +          rk(138)*yh(lMEK)
     &       +          rk(140)*yh(lMEOH)
     &       + ( 0.650)*rk(141)*yh(lCOOH)
     &       + ( 0.340)*rk(143)*yh(lROOH)
     &       +          rk(147)*yh(lGLY)
     &       +          rk(150)*yh(lMGLY)
     &       +          rk(153)*yh(lPHEN)
     &       +          rk(155)*yh(lCRES)
     &       +          rk(158)*yh(lBALD)
     &       +          rk(161)*yh(lMETH)
     &       +          rk(166)*yh(lMVK)
     &       +          rk(170)*yh(lISPD)
     &       +          rk(174)*yh(lPROD)
     &       +          rk(176)*yh(lRNO3)
     &       +          rk(178)*yh(lDCB1)
     &       +          rk(180)*yh(lDCB2)
     &       +          rk(182)*yh(lDCB3)
     &       +          rk(184)*CH4
     &       +          rk(185)*yh(lETHE)
     &       +          rk(189)*yh(lISOP)
     &       +          rk(193)*yh(lTERP)
     &       +          rk(197)*yh(lALK1)
     &       + ( 0.754)*rk(198)*yh(lALK2)
     &       +          rk(199)*yh(lALK3)
     &       +          rk(200)*yh(lALK4)
     &       +          rk(201)*yh(lALK5)
     &       +          rk(202)*yh(lARO1)
     &       +          rk(203)*yh(lARO2)
     &       +          rk(204)*yh(lOLE1)
     &       +          rk(208)*yh(lOLE2)
     &       +          rk(212)*yh(lETOH)
     &       +          rk(213)*yh(lMTBE)
     &       +          rk(214)*yh(lMBUT) )
c
c --- Loss of HO2, excluding self-reaction
c     (net either HO2 or OH produced)
c
      lsHO2 = 1.0 + rHO2_OH + rHO2_PNA + dt*(
     &       + ( 0.200)*rk( 39)*yh(lNO3)
     &       +          rk( 43)*yh(lOH)
     &       +          rk( 47)*yh(lCXO2)
     &       +          rk( 52)*yh(lRO2R)
     &       +          rk( 63)*yh(lRO2N)
     &       +          rk( 72)*yh(lCCO3)
     &       +          rk( 82)*yh(lRCO3)
     &       +          rk( 93)*yh(lBZCO)
     &       +          rk(105)*yh(lMCO3)
     &       +          rk(118)*yh(lBZO)
     &       +          rk(121)*yh(lBZNO)
     &       +          rk(126)*yh(lHCHO) )
c
c --- HO2 self-reaction
c
      self = dt*2.0*( 
     &       +          rk( 37)
     &       +          rk( 38)*H2O )
c
c --- Loss of HONO
c
      lsHONO = 1.0 + dt*(
     &       +          rk( 22)
     &       +          rk( 23)
     &       +          rk( 24)*yh(lOH) )
c
c --- Loss of PNA
c
      lsPNA = 1.0 + dt*(
     &       +          rk( 33)
     &       +          rk( 34)
     &       +          rk( 35)*yh(lOH) )
c
c --- Collect common terms
c
      t1 = 1.0 / ( lsOH*lsHONO - rHONO_OH*rOH_HONO )
      t2 = rOH_HO2*t1
      t3 = rPNA_HO2 / lsPNA
c
c --- Solve for HO2
c
      A = self
      B = lsHO2 - t3*rHO2_PNA - t2*rHO2_OH*lsHONO
      C = newHO2 + t3 * newPNA + t2*( newOH*lsHONO + newHONO*rHONO_OH )
      Q = -0.5 * (B + SIGN(1.0,B)*SQRT(B*B + 4.0*A*C))
c
c --- Update Concentrations
c
      y1(lHO2)  = MAX(1.0E-25, MAX(Q/A ,-C/Q) )
      y1(lOH)   = MAX(1.0E-25, ( ( newOH + rHO2_OH*y1(lHO2) )*lsHONO + 
     &                                        rHONO_OH*newHONO ) * t1 )
      y1(lHNO4)  = MAX(1.0E-25, ( newPNA + rHO2_PNA*y1(lHO2) ) / lsPNA )
      y1(lHONO) = MAX(1.0E-25, ( newHONO + rOH_HONO*y1(lOH) ) / lsHONO )
c
      return
      end

      subroutine hr_nox5(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
c
c----CAMx v4.53 090209
c
c     HR_NOX5 solves the NOx family using Hertel's equations
c
c     Copyright 1996-2009
c     ENVIRON International Corporation
c     Created by the CMC version 5
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      implicit none
      include "camx.prm"
      include "ddmchm.com"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real jO3_O1D, rNO2_O3P, rO3P_O3, rO3wNO
      real totO1D, totNO, totNO2, totO3P, totO3
      real lsO1D, lsNO, lsNO2, lsO3P, lsO3
      real yldO3P, rNO_NO2, rNO2_NO
      real t1, t2, t3, t4, t5, f1, f2, f3, f4, s1, s2, A, B, C, Q
c
c --- Entry Point
c
      N2 = M - O2
c
c --- O1D loss
c
      lsO1D = 
     &       + rk( 19)*H2O
     &       + rk( 20)*M
c
c --- Yield of O3P from O1D
c
      yldO3P  = ( rk( 20)*M ) / lsO1D
c
c --- Conversion of NO2 to NO
c     (rNO2_NO = rate of NO2 to NO)
c
      rNO2_NO  = dt*(
     &       +          rk(  1)
     &       +          rk(  5)*yh(lO) )
c
c --- NO production terms except rNO2_NO
c     (totNO = initial NO + new production)
c
      totNO = y0(lNO) + dt*(
     &       +          r( 14)
     &       +          r( 15)
     &       +          r( 22) )
c
c --- Net loss of NO
c     (net either NO or NO2 produced)
c
      lsNO = 1.0 + dt*(
     &       +          rk( 21)*yh(lOH)
     &       +          rk( 62)*yh(lRO2N) )
c
c --- Conversion of NO to NO2 except O3+NO (rO3wNO)
c
      rNO_NO2 = dt*(
     &       +          rk(  4)*yh(lO)*M
     &       +          rk(  9)*yh(lNO3)
     &       + ( 2.000)*rk( 10)*yh(lNO)*O2
     &       +          rk( 31)*yh(lHO2)
     &       +          rk( 46)*yh(lCXO2)
     &       +          rk( 51)*yh(lRO2R)
     &       +          rk( 56)*yh(lR2O2)
     &       +          rk( 71)*yh(lCCO3)
     &       +          rk( 81)*yh(lRCO3)
     &       +          rk( 92)*yh(lBZCO)
     &       +          rk(104)*yh(lMCO3)
     &       +          rk(128)*yh(lHCO3) )
c
c --- Remaining NO2 production
c
      totNO2 = y0(lNO2) + dt*(
     &       +          r(  9)
     &       +          r( 12)
     &       +          r( 16)
     &       +          r( 23)
     &       +          r( 24)
     &       +          r( 26)
     &       +          r( 28)
     &       +          r( 33)
     &       + ( 0.610)*r( 34)
     &       +          r( 35)
     &       + ( 0.800)*r( 39)
     &       + ( 2.000)*r( 40)
     &       +          r( 48)
     &       +          r( 53)
     &       +          r( 58)
     &       +          r( 65)
     &       +          r( 70)
     &       +          r( 73)
     &       +          r( 80)
     &       +          r( 83)
     &       +          r( 91)
     &       +          r( 94)
     &       +          r(103)
     &       +          r(106)
     &       + ( 0.338)*r(176)
     &       +          r(177)
     &       + ( 0.187)*r(191)
     &       + ( 0.474)*r(195)
     &       + ( 0.391)*r(210) )
c
c --- Net loss of NO2
c     (net either NO or NO2 produced)
c
      lsNO2 = 1.0 + dt*(
     &       +          rk(  6)*yh(lO)
     &       +          rk(  8)*yh(lO3)
     &       +          rk( 11)*yh(lNO3)
     &       +          rk( 25)*yh(lOH)
     &       +          rk( 32)*yh(lHO2)
     &       +          rk( 69)*yh(lCCO3)
     &       +          rk( 79)*yh(lRCO3)
     &       +          rk( 90)*yh(lBZCO)
     &       +          rk(102)*yh(lMCO3)
     &       +          rk(115)*yh(lTBUO)
     &       +          rk(117)*yh(lBZO)
     &       +          rk(120)*yh(lBZNO) )
c
c --- Production of O3P except NO2+hv
c
      totO3P = y0(lO) + dt*(
     &       +          r( 16)
     &       +          r( 17)
     &       +          r( 18)*yldO3P )
c
c --- Net loss of O3P
c
      lsO3P = 1.0 + dt*(
     &       +          rk(  2)*O2*M
     &       +          rk(  3)*yh(lO3)
     &       +          rk(  4)*yh(lNO)*M
     &       +          rk(  5)*yh(lNO2)
     &       +          rk(  6)*yh(lNO2)
     &       +          rk(164)*yh(lMETH)
     &       +          rk(168)*yh(lMVK)
     &       +          rk(188)*yh(lETHE)
     &       +          rk(192)*yh(lISOP)
     &       +          rk(196)*yh(lTERP)
     &       +          rk(207)*yh(lOLE1)
     &       +          rk(211)*yh(lOLE2)
     &       +          rk(217)*yh(lMBUT) )
c
c --- Production of O3 except O3P+O2
c
      totO3 = y0(lO3) + dt*(
     &       + ( 0.250)*r( 72)
     &       + ( 0.250)*r( 82)
     &       + ( 0.250)*r( 93)
     &       + ( 0.250)*r(105) )
c
c --- Net loss of O3 except O3+NO (rO3wNO)
c
      lsO3 = 1.0 + dt*(
     &       +          rk(  3)*yh(lO)
     &       +          rk(  8)*yh(lNO2)
     &       +          rk( 17)
     &       +          rk( 18)
     &       +          rk( 30)*yh(lOH)
     &       +          rk( 36)*yh(lHO2)
     &       +          rk(162)*yh(lMETH)
     &       +          rk(167)*yh(lMVK)
     &       +          rk(171)*yh(lISPD)
     &       +          rk(179)*yh(lDCB1)
     &       +          rk(186)*yh(lETHE)
     &       +          rk(190)*yh(lISOP)
     &       +          rk(194)*yh(lTERP)
     &       +          rk(205)*yh(lOLE1)
     &       +          rk(209)*yh(lOLE2)
     &       +          rk(215)*yh(lMBUT) )
c
c --- Specific reactions
c
      jO3_O1D  = rk( 18)
      rNO2_O3P = dt*rk(  1)
      rO3P_O3  = dt*rk(  2)*O2*M
      rO3wNO   = dt*rk(  7)
c
c --- Collect common terms
c
      t1 = rNO2_O3P / lsNO2
      t2 = rNO2_NO / lsNO2
      t3 = rNO_NO2 / lsNO
      t4 = rO3P_O3  / lsO3P
      t5 = t3*totNO - t2*totNO2
      f1 = 1.0 + t2 + t3
      f2 = t1*t4
      f3 = lsO3*lsNO + rO3wNO*totNO
      f4 = totO3 + totO3P * t4
c
c --- Solve for change in NO and NO2 
c
      A = rO3wNO * (f1 - f2)
      B = f1*f3 + rO3wNO*(f2*(totNO2 - totNO) + f4 + t5)
      C = rO3wNO*totNO*(f4 + totNO2 * f2) + f3*t5
      Q = -0.5 * (B + SIGN(1.0,B)*SQRT(B*B - 4.0*A*C))
      Q = MAX(Q/A ,C/Q)
c
c --- Update Concentrations
c
      y1(lNO)  = MAX(1.0E-25, (totNO + Q) / lsNO )
      y1(lNO2) = MAX(1.0E-25, (totNO2 - Q) / lsNO2 )
      s1 = totO3P + rNO2_O3P*y1(lNO2)
      s2 = t4*s1
      y1(lO3)  = MAX(1.0E-25, (totO3 + s2) / 
     &                             ( lsO3 + rO3wNO * y1(lNO) ) )
      y1(lO)   = MAX(1.0E-35, s1 / lsO3P )
      totO1D = jO3_O1D*y1(lO3)
      y1(lO1D) = MAX(1.0E-35, totO1D / lsO1D )
c
      return
      end

      subroutine hr_nxy5(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
c
c----CAMx v4.53 090209
c
c     HR_NXY5 solves NO3 and N2O5 using Hertel's equations
c
c     Copyright 1996-2009
c     ENVIRON International Corporation
c     Created by the CMC version 5
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      implicit none
      include "camx.prm"
      include "ddmchm.com"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real self, fwd, bck
      real newNO3, lsNO3, lsN2O5, totNO3, A, B, C, Q, t1
c
c --- Entry Point
c
      N2 = M - O2
c
      newNO3 = 
     &       +          r(  6)
     &       +          r(  8)
     &       +          r( 27)
     &       + ( 0.390)*r( 34) 
c
      lsN2O5 = 
     &       +          rk( 12)
     &       +          rk( 13)*H2O 
c
      lsNO3 = 
     &       +          rk(  9)*yh(lNO)
     &       +          rk( 11)*yh(lNO2)
     &       +          rk( 14)*yh(lNO2)
     &       +          rk( 15)
     &       +          rk( 16)
     &       +          rk( 26)*yh(lOH)
     &       +          rk( 39)*yh(lHO2)
     &       +          rk( 48)*yh(lCXO2)
     &       +          rk( 53)*yh(lRO2R)
     &       +          rk( 58)*yh(lR2O2)
     &       +          rk( 65)*yh(lRO2N)
     &       +          rk( 73)*yh(lCCO3)
     &       +          rk( 83)*yh(lRCO3)
     &       +          rk( 94)*yh(lBZCO)
     &       +          rk(106)*yh(lMCO3)
     &       +          rk(129)*yh(lHCHO)
     &       +          rk(132)*yh(lCCHO)
     &       +          rk(135)*yh(lRCHO)
     &       +          rk(148)*yh(lGLY)
     &       +          rk(151)*yh(lMGLY)
     &       +          rk(154)*yh(lPHEN)
     &       +          rk(156)*yh(lCRES)
     &       +          rk(157)*yh(lNPHE)
     &       +          rk(160)*yh(lBALD)
     &       +          rk(163)*yh(lMETH)
     &       +          rk(172)*yh(lISPD)
     &       +          rk(187)*yh(lETHE)
     &       +          rk(191)*yh(lISOP)
     &       +          rk(195)*yh(lTERP)
     &       +          rk(206)*yh(lOLE1)
     &       +          rk(210)*yh(lOLE2)
     &       +          rk(216)*yh(lMBUT) 
c
      self = dt*rk( 40)
      fwd = dt*( rk( 11) ) * yh(lNO2)
      bck = dt*( rk( 12) )
c
c --- Collect terms
c
      t1 = 1.0 + dt*lsN2O5
      A = 2.0*fwd*t1
      B = t1*( 1.0 + dt*lsNO3 ) - bck*fwd
      C = t1*( y0(lNO3) + dt*newNO3 ) + bck*y0(lN2O5)
      Q = -0.5*(B + SIGN(1.0,B)*SQRT(B*B + 4.0*A*C))
      Q = MAX(Q/A ,-C/Q)
c
c --- Update Concentrations
c
      y1(lNO3)  = MAX(1.0E-25, Q)
      y1(lN2O5) = MAX(1.0E-25, ( y0(lN2O5) + fwd*y1(lNO3) )/t1)
c
      return
      end

      subroutine hr_pan5(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
c
c----CAMx v4.53 090209
c
c     HR_PAN5 solves PAN and RCO3 using Hertel's equations
c
c     Copyright 1996-2009
c     ENVIRON International Corporation
c     Created by the CMC version 5
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      implicit none
      include "camx.prm"
      include "ddmchm.com"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real fwd, bck, self, A, B, C, Q
      real newRCO3, lsPAN, lsRCO3
c
c --- Entry Point
c
      N2 = M - O2
c
      newRCO3 = 
     &       +          r(104)
     &       +          r(106)
     &       +          r(112)
     &       +          r(113)
     &       + ( 2.000)*r(114)
     &       +          r(130)
     &       +          r(132)
     &       +          r(136)
     &       +          r(137)
     &       + ( 0.492)*r(138)
     &       +          r(139)
     &       +          r(149)
     &       +          r(150)
     &       +          r(151)
     &       + ( 2.000)*r(152)
     &       + ( 0.670)*r(165)
     &       + ( 0.675)*r(166)
     &       + ( 0.467)*r(173)
     &       + ( 0.029)*r(174)
     &       + ( 0.667)*r(175)
     &       +          r(180)
     &       + ( 0.500)*r(181)
     &       +          r(182)
     &       + ( 0.500)*r(183)
     &       + ( 0.123)*r(194)
     &       + ( 0.011)*r(200)
     &       + ( 0.137)*r(209) 
c
      lsRCO3 = 
     &       +          rk( 69)*yh(lNO2)
     &       +          rk( 71)*yh(lNO)
     &       +          rk( 72)*yh(lHO2)
     &       +          rk( 73)*yh(lNO3)
     &       +          rk( 74)*yh(lCXO2)
     &       +          rk( 75)*yh(lRO2R)
     &       +          rk( 77)*yh(lRO2N)
     &       +          rk( 88)*yh(lRCO3)
     &       +          rk( 99)*yh(lBZCO) 
c
      lsPAN = 
     &       + rk( 70)
c
      fwd  = dt*( rk( 69) ) * yh(lNO2)
      bck  = dt*( rk( 70) )
      self = dt*rk( 78)
      lsPAN  = 1.0 + dt*lsPAN
      lsRCO3 = 1.0 + dt*lsRCO3
c
c-----Solve for peroxyacetyl radical
c
      A = 2.0 * self * lsPAN
      B = ( lsPAN*lsRCO3) - (fwd*bck)
      C = lsPAN*( y0(lCCO3) + newRCO3*dt ) + bck*y0(lPAN)
      Q = -0.5 * ( B + SIGN(1.0,B)*SQRT(B*B + 4.0*A*C) )
c
c --- Update Concentrations
c
      y1(lCCO3) = MAX(1.0E-25, MAX(Q/A, -C/Q) )
      y1(lPAN)  = MAX(1.0E-25, (y0(lPAN) + fwd*y1(lCCO3)) / lsPAN )
c
      return
      end

