      subroutine ierate5(neq,t,y,rate,nr,r)
c
c----CAMx v4.53 090209
c
c     IERATE5 computes rates for IEH solver fast species
c
c     Copyright 1996-2009
c     ENVIRON International Corporation
c     Created by the CMC version 5
c
c     Routines Called:
c        IERXN5
c
c     Called by:
c        LSODE
c
      implicit none
      include "camx.prm"
      include "iehchem.com"
      include "lsbox.com"
c
      integer neq(3), ny, nr, nk, l
      real t, H2O, M, O2, CH4, H2, N2
      real rate(neq(1)), y(neq(2)+6)
      real loss(MXSPEC+MXRADCL+1), gain(MXSPEC+MXRADCL+1), r(neq(3))
c
c --- Entry point
c
      ny = neq(2)
      nk = neq(3)
      H2O = y(ny+2)
      M   = y(ny+3)
      O2  = y(ny+4)
      CH4 = y(ny+5)
      H2  = y(ny+6)
      N2  = M - O2
c
      do l=1,ny
        Loss(l) = 0.0
        Gain(l) = 0.0
      enddo
c
c --- Get the reaction rates
c
      call ierxn5(y,ny,r,rrk,nk)
c
c --- Solve the steady state species
c
c
c   O1D
c
        Loss(iO1D  )= +( 1.000)*r( 19)+( 1.000)*r( 20)
c
        Gain(iO1D  )= +( 1.000)*r( 18)
c
      if (loss(iO1D).gt.1.0e-25.or.loss(iO1D).lt.-1.0e-25) then
        y(iO1D) = gain(iO1D)/loss(iO1D)*y(iO1D)
      else
        y(iO1D) = 0.0
      endif
      r( 19) = rrk( 19)*y(iO1D)*H2O
      r( 20) = rrk( 20)*y(iO1D)*M
c
c     O
c
        Loss(iO    )= +( 1.000)*r(  2)+( 1.000)*r(  3)+( 1.000)*r(  4)
     &                +( 1.000)*r(  5)+( 1.000)*r(  6)+( 1.000)*r(164)
     &                +( 1.000)*r(168)+( 1.000)*r(188)+( 1.000)*r(192)
     &                +( 1.000)*r(196)+( 1.000)*r(207)+( 1.000)*r(211)
     &                +( 1.000)*r(217)
c
        Gain(iO    )= +( 1.000)*r(  1)+( 1.000)*r( 16)+( 1.000)*r( 17)
     &                +( 1.000)*r( 20)
c
      if (loss(iO).gt.1.0e-25.or.loss(iO).lt.-1.0e-25) then
        y(iO) = gain(iO)/loss(iO)*y(iO)
      else
        y(iO) = 0.0
      endif
      r(  2) = rrk(  2)*y(iO)*O2*M
      r(  3) = rrk(  3)*y(iO)*y(iO3)
      r(  4) = rrk(  4)*y(iO)*y(iNO)*M
      r(  5) = rrk(  5)*y(iO)*y(iNO2)
      r(  6) = rrk(  6)*y(iO)*y(iNO2)
      r(164) = rrk(164)*y(iMETH)*y(iO)
      r(168) = rrk(168)*y(iMVK)*y(iO)
      r(188) = rrk(188)*y(iETHE)*y(iO)
      r(192) = rrk(192)*y(iISOP)*y(iO)
      r(196) = rrk(196)*y(iTERP)*y(iO)
      r(207) = rrk(207)*y(iOLE1)*y(iO)
      r(211) = rrk(211)*y(iOLE2)*y(iO)
      r(217) = rrk(217)*y(iMBUT)*y(iO)
c
c --- Calculate the species rates
c
c
c  N2O5   NO3    OH   HO2  RO2R  R2O2  RO2N  CCO3  RCO3  MCO3
c  BZCO  CXO2  HCO3  TBUO   BZO  BZNO    NO   NO2    O3   PAN
c  PAN2  MPAN  PBZN  NPHE  CRES  DCB2  DCB3  RNO3  HNO4
c
        Loss(iN2O5 )= +( 1.000)*r( 12)+( 1.000)*r( 13)
c
        Gain(iN2O5 )= +( 1.000)*r( 11)
c
        Loss(iNO3  )= +( 1.000)*r(  9)+( 1.000)*r( 11)+( 1.000)*r( 14)
     &                +( 1.000)*r( 15)+( 1.000)*r( 16)+( 1.000)*r( 26)
     &                +( 1.000)*r( 39)+( 2.000)*r( 40)+( 1.000)*r( 48)
     &                +( 1.000)*r( 53)+( 1.000)*r( 58)+( 1.000)*r( 65)
     &                +( 1.000)*r( 73)+( 1.000)*r( 83)+( 1.000)*r( 94)
     &                +( 1.000)*r(106)+( 1.000)*r(129)+( 1.000)*r(132)
     &                +( 1.000)*r(135)+( 1.000)*r(148)+( 1.000)*r(151)
     &                +( 1.000)*r(154)+( 1.000)*r(156)+( 1.000)*r(157)
     &                +( 1.000)*r(160)+( 1.000)*r(163)+( 1.000)*r(172)
        Loss(iNO3  ) = Loss(iNO3  )
     &                +( 1.000)*r(187)+( 1.000)*r(191)+( 1.000)*r(195)
     &                +( 1.000)*r(206)+( 1.000)*r(210)+( 1.000)*r(216)
c
        Gain(iNO3  )= +( 1.000)*r(  6)+( 1.000)*r(  8)+( 1.000)*r( 12)
     &                +( 1.000)*r( 27)+( 0.390)*r( 34)
c
        Loss(iOH   )= +( 1.000)*r( 21)+( 1.000)*r( 24)+( 1.000)*r( 25)
     &                +( 1.000)*r( 26)+( 1.000)*r( 27)+( 1.000)*r( 29)
     &                +( 1.000)*r( 30)+( 1.000)*r( 35)+( 1.000)*r( 42)
     &                +( 1.000)*r( 43)+( 1.000)*r( 44)+( 1.000)*r( 45)
     &                +( 1.000)*r(125)+( 1.000)*r(130)+( 1.000)*r(133)
     &                +( 1.000)*r(136)+( 1.000)*r(138)+( 1.000)*r(140)
     &                +( 1.000)*r(141)+( 1.000)*r(143)+( 1.000)*r(147)
     &                +( 1.000)*r(150)+( 1.000)*r(153)+( 1.000)*r(155)
     &                +( 1.000)*r(158)+( 1.000)*r(161)+( 1.000)*r(166)
        Loss(iOH   ) = Loss(iOH   )
     &                +( 1.000)*r(170)+( 1.000)*r(174)+( 1.000)*r(176)
     &                +( 1.000)*r(178)+( 1.000)*r(180)+( 1.000)*r(182)
     &                +( 1.000)*r(184)+( 1.000)*r(185)+( 1.000)*r(189)
     &                +( 1.000)*r(193)+( 1.000)*r(197)+( 1.000)*r(198)
     &                +( 1.000)*r(199)+( 1.000)*r(200)+( 1.000)*r(201)
     &                +( 1.000)*r(202)+( 1.000)*r(203)+( 1.000)*r(204)
     &                +( 1.000)*r(208)+( 1.000)*r(212)+( 1.000)*r(213)
     &                +( 1.000)*r(214)
c
        Gain(iOH   )= +( 2.000)*r( 19)+( 1.000)*r( 22)+( 1.000)*r( 28)
     &                +( 1.000)*r( 31)+( 0.390)*r( 34)+( 1.000)*r( 36)
     &                +( 0.800)*r( 39)+( 2.000)*r( 41)+( 0.350)*r(141)
     &                +( 1.000)*r(142)+( 0.660)*r(143)+( 1.000)*r(144)
     &                +( 0.208)*r(162)+( 0.330)*r(165)+( 0.164)*r(167)
     &                +( 0.285)*r(171)+( 0.500)*r(179)+( 0.120)*r(186)
     &                +( 0.266)*r(190)+( 0.567)*r(194)+( 0.246)*r(198)
     &                +( 0.155)*r(205)+( 0.378)*r(209)+( 0.099)*r(215)
c
        Loss(iHO2  )= +( 1.000)*r( 31)+( 1.000)*r( 32)+( 1.000)*r( 36)
     &                +( 2.000)*r( 37)+( 2.000)*r( 38)+( 1.000)*r( 39)
     &                +( 1.000)*r( 43)+( 1.000)*r( 47)+( 1.000)*r( 52)
     &                +( 1.000)*r( 57)+( 1.000)*r( 63)+( 1.000)*r( 72)
     &                +( 1.000)*r( 82)+( 1.000)*r( 93)+( 1.000)*r(105)
     &                +( 1.000)*r(118)+( 1.000)*r(121)+( 1.000)*r(126)
c
        Gain(iHO2  )= +( 1.000)*r( 23)+( 1.000)*r( 26)+( 1.000)*r( 29)
     &                +( 1.000)*r( 30)+( 1.000)*r( 33)+( 0.610)*r( 34)
     &                +( 1.000)*r( 42)+( 1.000)*r( 44)+( 1.000)*r( 45)
     &                +( 1.000)*r( 46)+( 1.000)*r( 48)+( 2.000)*r( 50)
     &                +( 1.000)*r( 51)+( 1.000)*r( 53)+( 1.000)*r( 54)
     &                +( 1.000)*r( 55)+( 1.000)*r( 57)+( 1.000)*r( 64)
     &                +( 1.000)*r( 65)+( 1.000)*r( 66)+( 1.000)*r( 68)
     &                +( 2.000)*r(123)+( 1.000)*r(125)+( 1.000)*r(127)
     &                +( 1.000)*r(128)+( 1.000)*r(129)+( 1.000)*r(131)
        Gain(iHO2  ) = Gain(iHO2  )
     &                +( 1.000)*r(134)+( 1.000)*r(140)+( 1.000)*r(142)
     &                +( 1.000)*r(144)+( 2.000)*r(145)+( 0.630)*r(147)
     &                +( 0.630)*r(148)+( 1.000)*r(149)+( 0.008)*r(162)
     &                +( 0.340)*r(165)+( 0.064)*r(167)+( 0.400)*r(171)
     &                +( 1.233)*r(173)+( 0.379)*r(174)+( 0.113)*r(176)
     &                +( 0.341)*r(177)+( 1.500)*r(179)+( 0.500)*r(181)
     &                +( 0.500)*r(183)+( 0.120)*r(186)+( 0.500)*r(188)
     &                +( 0.033)*r(194)+( 0.121)*r(198)+( 0.224)*r(202)
        Gain(iHO2  ) = Gain(iHO2  )
     &                +( 0.187)*r(203)+( 0.056)*r(205)+( 0.003)*r(209)
     &                +( 0.013)*r(211)+( 0.950)*r(212)+( 0.099)*r(215)
c
        Loss(iRO2R )= +( 1.000)*r( 51)+( 1.000)*r( 52)+( 1.000)*r( 53)
     &                +( 1.000)*r( 54)+( 2.000)*r( 55)+( 1.000)*r( 60)
     &                +( 1.000)*r( 66)+( 1.000)*r( 75)+( 1.000)*r( 85)
     &                +( 1.000)*r( 96)+( 1.000)*r(108)
c
        Gain(iRO2R )= +( 1.000)*r( 60)+( 1.000)*r( 81)+( 1.000)*r( 83)
     &                +( 1.000)*r( 88)+( 2.000)*r( 89)+( 1.000)*r(100)
     &                +( 1.000)*r(112)+( 0.034)*r(133)+( 1.000)*r(134)
     &                +( 0.370)*r(138)+( 1.000)*r(139)+( 0.340)*r(143)
     &                +( 0.760)*r(153)+( 0.760)*r(155)+( 0.500)*r(161)
     &                +( 0.100)*r(162)+( 0.500)*r(163)+( 0.330)*r(165)
     &                +( 0.300)*r(166)+( 0.050)*r(167)+( 0.670)*r(170)
     &                +( 0.048)*r(171)+( 0.799)*r(172)+( 0.473)*r(174)
     &                +( 0.960)*r(175)+( 0.376)*r(176)+( 0.564)*r(177)
        Gain(iRO2R ) = Gain(iRO2R )
     &                +( 1.000)*r(178)+( 1.000)*r(181)+( 1.000)*r(183)
     &                +( 1.000)*r(185)+( 1.000)*r(187)+( 0.200)*r(188)
     &                +( 0.907)*r(189)+( 0.066)*r(190)+( 0.749)*r(191)
     &                +( 0.750)*r(193)+( 0.031)*r(194)+( 0.276)*r(195)
     &                +( 1.000)*r(197)+( 0.612)*r(198)+( 0.695)*r(199)
     &                +( 0.835)*r(200)+( 0.653)*r(201)+( 0.765)*r(202)
     &                +( 0.804)*r(203)+( 0.910)*r(204)+( 0.022)*r(205)
     &                +( 0.824)*r(206)+( 0.918)*r(208)+( 0.033)*r(209)
        Gain(iRO2R ) = Gain(iRO2R )
     &                +( 0.442)*r(210)+( 0.012)*r(211)+( 0.050)*r(212)
     &                +( 0.743)*r(213)+( 0.935)*r(214)+( 0.935)*r(216)
c
        Loss(iR2O2 )= +( 1.000)*r( 56)+( 1.000)*r( 57)+( 1.000)*r( 58)
     &                +( 1.000)*r( 59)+( 1.000)*r( 60)+( 2.000)*r( 61)
     &                +( 1.000)*r( 67)+( 1.000)*r( 76)+( 1.000)*r( 86)
     &                +( 1.000)*r( 97)+( 1.000)*r(109)
c
        Gain(iR2O2 )= +( 1.000)*r( 92)+( 1.000)*r( 94)+( 1.000)*r( 99)
     &                +( 1.000)*r(100)+( 2.000)*r(101)+( 1.000)*r(113)
     &                +( 1.000)*r(136)+( 0.616)*r(138)+( 0.675)*r(166)
     &                +( 0.515)*r(175)+( 0.596)*r(176)+( 0.152)*r(177)
     &                +( 1.000)*r(180)+( 1.000)*r(181)+( 1.000)*r(182)
     &                +( 1.000)*r(183)+( 0.079)*r(189)+( 0.126)*r(190)
     &                +( 0.187)*r(191)+( 0.240)*r(192)+( 0.500)*r(193)
     &                +( 0.729)*r(194)+( 0.750)*r(195)+( 0.559)*r(199)
     &                +( 0.936)*r(200)+( 0.948)*r(201)+( 0.205)*r(204)
        Gain(iR2O2 ) = Gain(iR2O2 )
     &                +( 0.488)*r(206)+( 0.001)*r(208)+( 0.137)*r(209)
     &                +( 0.711)*r(210)+( 0.381)*r(213)
c
        Loss(iRO2N )= +( 1.000)*r( 62)+( 1.000)*r( 63)+( 1.000)*r( 64)
     &                +( 1.000)*r( 65)+( 1.000)*r( 66)+( 1.000)*r( 67)
     &                +( 2.000)*r( 68)+( 1.000)*r( 77)+( 1.000)*r( 87)
     &                +( 1.000)*r( 98)+( 1.000)*r(110)
c
        Gain(iRO2N )= +( 1.000)*r( 67)+( 0.001)*r(133)+( 0.042)*r(138)
     &                +( 0.025)*r(166)+( 0.041)*r(170)+( 0.051)*r(172)
     &                +( 0.070)*r(174)+( 0.040)*r(175)+( 0.173)*r(176)
     &                +( 0.095)*r(177)+( 0.093)*r(189)+( 0.008)*r(190)
     &                +( 0.064)*r(191)+( 0.010)*r(192)+( 0.250)*r(193)
     &                +( 0.180)*r(194)+( 0.250)*r(195)+( 0.021)*r(198)
     &                +( 0.070)*r(199)+( 0.143)*r(200)+( 0.347)*r(201)
     &                +( 0.011)*r(202)+( 0.009)*r(203)+( 0.090)*r(204)
     &                +( 0.001)*r(205)+( 0.176)*r(206)+( 0.082)*r(208)
        Gain(iRO2N ) = Gain(iRO2N )
     &                +( 0.002)*r(209)+( 0.136)*r(210)+( 0.001)*r(211)
     &                +( 0.078)*r(213)+( 0.065)*r(214)+( 0.065)*r(216)
c
        Loss(iCCO3 )= +( 1.000)*r( 69)+( 1.000)*r( 71)+( 1.000)*r( 72)
     &                +( 1.000)*r( 73)+( 1.000)*r( 74)+( 1.000)*r( 75)
     &                +( 1.000)*r( 76)+( 1.000)*r( 77)+( 2.000)*r( 78)
     &                +( 1.000)*r( 88)+( 1.000)*r( 99)+( 1.000)*r(111)
c
        Gain(iCCO3 )= +( 1.000)*r( 70)+( 1.000)*r( 76)+( 1.000)*r(104)
     &                +( 1.000)*r(106)+( 1.000)*r(111)+( 1.000)*r(112)
     &                +( 1.000)*r(113)+( 2.000)*r(114)+( 1.000)*r(130)
     &                +( 1.000)*r(132)+( 1.000)*r(136)+( 1.000)*r(137)
     &                +( 0.492)*r(138)+( 1.000)*r(139)+( 1.000)*r(149)
     &                +( 1.000)*r(150)+( 1.000)*r(151)+( 2.000)*r(152)
     &                +( 0.670)*r(165)+( 0.675)*r(166)+( 0.467)*r(173)
     &                +( 0.029)*r(174)+( 0.667)*r(175)+( 1.000)*r(180)
     &                +( 0.500)*r(181)+( 1.000)*r(182)+( 0.500)*r(183)
        Gain(iCCO3 ) = Gain(iCCO3 )
     &                +( 0.123)*r(194)+( 0.011)*r(200)+( 0.137)*r(209)
c
        Loss(iRCO3 )= +( 1.000)*r( 79)+( 1.000)*r( 81)+( 1.000)*r( 82)
     &                +( 1.000)*r( 83)+( 1.000)*r( 84)+( 1.000)*r( 85)
     &                +( 1.000)*r( 86)+( 1.000)*r( 87)+( 1.000)*r( 88)
     &                +( 2.000)*r( 89)+( 1.000)*r(100)+( 1.000)*r(112)
c
        Gain(iRCO3 )= +( 1.000)*r( 80)+( 1.000)*r( 86)+( 0.965)*r(133)
     &                +( 1.000)*r(135)+( 0.096)*r(138)+( 0.370)*r(147)
     &                +( 0.370)*r(148)+( 0.100)*r(162)+( 0.050)*r(167)
     &                +( 0.048)*r(171)+( 0.300)*r(173)+( 0.049)*r(174)
     &                +( 0.333)*r(175)+( 0.201)*r(194)+( 0.006)*r(209)
c
        Loss(iMCO3 )= +( 1.000)*r(102)+( 1.000)*r(104)+( 1.000)*r(105)
     &                +( 1.000)*r(106)+( 1.000)*r(107)+( 1.000)*r(108)
     &                +( 1.000)*r(109)+( 1.000)*r(110)+( 1.000)*r(111)
     &                +( 1.000)*r(112)+( 1.000)*r(113)+( 2.000)*r(114)
c
        Gain(iMCO3 )= +( 1.000)*r(103)+( 1.000)*r(109)+( 0.500)*r(161)
     &                +( 0.500)*r(163)+( 0.330)*r(165)+( 0.300)*r(169)
     &                +( 0.289)*r(170)+( 0.150)*r(172)+( 0.192)*r(190)
     &                +( 0.240)*r(192)
c
        Loss(iBZCO )= +( 1.000)*r( 90)+( 1.000)*r( 92)+( 1.000)*r( 93)
     &                +( 1.000)*r( 94)+( 1.000)*r( 95)+( 1.000)*r( 96)
     &                +( 1.000)*r( 97)+( 1.000)*r( 98)+( 1.000)*r( 99)
     &                +( 1.000)*r(100)+( 2.000)*r(101)+( 1.000)*r(113)
c
        Gain(iBZCO )= +( 1.000)*r( 91)+( 1.000)*r( 97)+( 1.000)*r(158)
     &                +( 1.000)*r(160)
c
        Loss(iCXO2 )= +( 1.000)*r( 46)+( 1.000)*r( 47)+( 1.000)*r( 48)
     &                +( 2.000)*r( 49)+( 2.000)*r( 50)+( 1.000)*r( 54)
     &                +( 1.000)*r( 59)+( 1.000)*r( 64)+( 1.000)*r( 74)
     &                +( 1.000)*r( 84)+( 1.000)*r( 95)+( 1.000)*r(107)
c
        Gain(iCXO2 )= +( 1.000)*r( 59)+( 1.000)*r( 71)+( 1.000)*r( 73)
     &                +( 2.000)*r( 78)+( 1.000)*r( 88)+( 1.000)*r( 99)
     &                +( 1.000)*r(111)+( 1.000)*r(116)+( 1.000)*r(131)
     &                +( 1.000)*r(137)+( 0.650)*r(141)+( 0.300)*r(169)
     &                +( 1.000)*r(184)+( 0.300)*r(188)+( 0.250)*r(192)
     &                +( 0.011)*r(200)+( 0.076)*r(205)+( 0.197)*r(209)
     &                +( 0.030)*r(210)+( 0.162)*r(213)
c
        Loss(iHCO3 )= +( 1.000)*r(127)+( 1.000)*r(128)
c
        Gain(iHCO3 )= +( 1.000)*r(126)
c
        Loss(iTBUO )= +( 1.000)*r(115)+( 1.000)*r(116)
c
        Gain(iTBUO )= +( 0.236)*r(199)+( 0.016)*r(213)
c
        Loss(iBZO  )= +( 1.000)*r(117)+( 1.000)*r(118)+( 1.000)*r(119)
c
        Gain(iBZO  )= +( 1.000)*r( 92)+( 1.000)*r( 94)+( 1.000)*r( 99)
     &                +( 1.000)*r(100)+( 2.000)*r(101)+( 1.000)*r(113)
     &                +( 0.240)*r(153)+( 1.000)*r(154)+( 0.240)*r(155)
     &                +( 1.000)*r(156)
c
        Loss(iBZNO )= +( 1.000)*r(120)+( 1.000)*r(121)+( 1.000)*r(122)
c
        Gain(iBZNO )= +( 1.000)*r(157)
c
        Loss(iNO   )= +( 1.000)*r(  4)+( 1.000)*r(  7)+( 1.000)*r(  9)
     &                +( 2.000)*r( 10)+( 1.000)*r( 21)+( 1.000)*r( 31)
     &                +( 1.000)*r( 46)+( 1.000)*r( 51)+( 1.000)*r( 56)
     &                +( 1.000)*r( 62)+( 1.000)*r( 71)+( 1.000)*r( 81)
     &                +( 1.000)*r( 92)+( 1.000)*r(104)+( 1.000)*r(128)
c
        Gain(iNO   )= +( 1.000)*r(  1)+( 1.000)*r(  5)+( 1.000)*r( 14)
     &                +( 1.000)*r( 15)+( 1.000)*r( 22)
c
        Loss(iNO2  )= +( 1.000)*r(  1)+( 1.000)*r(  5)+( 1.000)*r(  6)
     &                +( 1.000)*r(  8)+( 1.000)*r( 11)+( 1.000)*r( 14)
     &                +( 1.000)*r( 25)+( 1.000)*r( 32)+( 1.000)*r( 69)
     &                +( 1.000)*r( 79)+( 1.000)*r( 90)+( 1.000)*r(102)
     &                +( 1.000)*r(115)+( 1.000)*r(117)+( 1.000)*r(120)
c
        Gain(iNO2  )= +( 1.000)*r(  4)+( 1.000)*r(  7)+( 2.000)*r(  9)
     &                +( 2.000)*r( 10)+( 1.000)*r( 12)+( 1.000)*r( 14)
     &                +( 1.000)*r( 16)+( 1.000)*r( 23)+( 1.000)*r( 24)
     &                +( 1.000)*r( 26)+( 1.000)*r( 28)+( 1.000)*r( 31)
     &                +( 1.000)*r( 33)+( 0.610)*r( 34)+( 1.000)*r( 35)
     &                +( 0.800)*r( 39)+( 2.000)*r( 40)+( 1.000)*r( 46)
     &                +( 1.000)*r( 48)+( 1.000)*r( 51)+( 1.000)*r( 53)
     &                +( 1.000)*r( 56)+( 1.000)*r( 58)+( 1.000)*r( 65)
     &                +( 1.000)*r( 70)+( 1.000)*r( 71)+( 1.000)*r( 73)
        Gain(iNO2  ) = Gain(iNO2  )
     &                +( 1.000)*r( 80)+( 1.000)*r( 81)+( 1.000)*r( 83)
     &                +( 1.000)*r( 91)+( 1.000)*r( 92)+( 1.000)*r( 94)
     &                +( 1.000)*r(103)+( 1.000)*r(104)+( 1.000)*r(106)
     &                +( 1.000)*r(128)+( 0.338)*r(176)+( 1.000)*r(177)
     &                +( 0.187)*r(191)+( 0.474)*r(195)+( 0.391)*r(210)
c
        Loss(iO3   )= +( 1.000)*r(  3)+( 1.000)*r(  7)+( 1.000)*r(  8)
     &                +( 1.000)*r( 17)+( 1.000)*r( 18)+( 1.000)*r( 30)
     &                +( 1.000)*r( 36)+( 1.000)*r(162)+( 1.000)*r(167)
     &                +( 1.000)*r(171)+( 1.000)*r(179)+( 1.000)*r(186)
     &                +( 1.000)*r(190)+( 1.000)*r(194)+( 1.000)*r(205)
     &                +( 1.000)*r(209)+( 1.000)*r(215)
c
        Gain(iO3   )= +( 1.000)*r(  2)+( 0.250)*r( 72)+( 0.250)*r( 82)
     &                +( 0.250)*r( 93)+( 0.250)*r(105)
c
        Loss(iPAN  )= +( 1.000)*r( 70)
c
        Gain(iPAN  )= +( 1.000)*r( 69)
c
        Loss(iPAN2 )= +( 1.000)*r( 80)
c
        Gain(iPAN2 )= +( 1.000)*r( 79)
c
        Loss(iMPAN )= +( 1.000)*r(103)
c
        Gain(iMPAN )= +( 1.000)*r(102)
c
        Loss(iPBZN )= +( 1.000)*r( 91)
c
        Gain(iPBZN )= +( 1.000)*r( 90)
c
        Loss(iNPHE )= +( 1.000)*r(157)
c
        Gain(iNPHE )= +( 1.000)*r(117)+( 1.000)*r(121)+( 1.000)*r(122)
c
        Loss(iCRES )= +( 1.000)*r(155)+( 1.000)*r(156)
c
        Gain(iCRES )= +( 0.207)*r(202)+( 0.187)*r(203)
c
        Loss(iDCB2 )= +( 1.000)*r(180)+( 1.000)*r(181)
c
        Gain(iDCB2 )= +( 0.108)*r(202)+( 0.099)*r(203)
c
        Loss(iDCB3 )= +( 1.000)*r(182)+( 1.000)*r(183)
c
        Gain(iDCB3 )= +( 0.051)*r(202)+( 0.093)*r(203)
c
        Loss(iRNO3 )= +( 1.000)*r(176)+( 1.000)*r(177)
c
        Gain(iRNO3 )= +( 1.000)*r( 62)+( 1.000)*r(115)+( 0.572)*r(172)
     &                +( 0.310)*r(176)+( 0.813)*r(191)+( 0.276)*r(195)
     &                +( 0.511)*r(206)+( 0.321)*r(210)+( 1.000)*r(216)
c
        Loss(iHNO4 )= +( 1.000)*r( 33)+( 1.000)*r( 34)+( 1.000)*r( 35)
c
        Gain(iHNO4 )= +( 1.000)*r( 32)
c
c
      do l=1,neq(1)
        rate(l) = gain(l) -loss(l)
      enddo
c
      return
      end
