      subroutine lsrate1(neq,t,y,rate,nr,r)
c
c----CAMx v4.53 090209
c
c     LSRATE1 computes a full set of rates
c
c     Copyright 1996-2009
c     ENVIRON International Corporation
c
c     Routines Called:
c        none
c
c     Called by:
c        LSODE
c
      implicit none
      include "camx.prm"
      include "lsbox.com"
      include "ddmchm.com"
c
      integer neq, nr, l
      double precision rate(neq), y(mxradcl+mxspec+1), r(mxrxn)
      double precision loss(mxradcl+mxspec+1),gain(mxradcl+mxspec+1)
      double precision t
c
c-----Get reaction rates, r
c
      call lsrxn1(dH2O,dM,dO2,dCH4,dH2,y,dbrk,r)
c
      do l=1,neq
        Loss(l) = 0.d0
        Gain(l) = 0.d0
      enddo
c
c-----Calculate the species rates
c
c
c   NO2    NO     O    O3   NO3   O1D    OH   HO2  N2O5  HNO3
c  HONO   PNA  H2O2    CO  FORM  ALD2  C2O3   XO2   PAN   PAR
c  XO2N   ROR   NTR   OLE   ETH   TOL  CRES   TO2  OPEN   CRO
c  MGLY   XYL  ISOP  ISPD   SO2  SULF  MEOH  ETOH   CL2    CL
c  HOCL   CLO   HCL  RCHO  FMCL  ICL1  ICL2  BUTA  BCL1  BCL2
c
c
        Loss(lNO2  )= +( 1.000)*r(  1)+( 1.000)*r(  4)+( 1.000)*r(  5)
     &                +( 1.000)*r(  7)+( 1.000)*r( 16)+( 1.000)*r( 17)
     &                +( 1.000)*r( 21)+( 1.000)*r( 26)+( 1.000)*r( 29)
     &                +( 1.000)*r( 47)+( 1.000)*r( 55)+( 1.000)*r( 68)
     &                +( 1.000)*r( 96)
        Gain(lNO2  )= +( 1.000)*r(  3)+( 1.000)*r(  6)+( 0.890)*r( 14)
     &                +( 2.000)*r( 15)+( 1.000)*r( 16)+( 1.000)*r( 19)
     &                +( 2.000)*r( 20)+( 1.000)*r( 24)+( 1.000)*r( 25)
     &                +( 1.000)*r( 28)+( 1.000)*r( 30)+( 1.000)*r( 31)
     &                +( 1.000)*r( 46)+( 1.000)*r( 48)+( 1.000)*r( 59)
     &                +( 0.900)*r( 64)+( 0.200)*r( 78)+( 1.000)*r( 79)
     &                +( 1.000)*r(100)
        Loss(lNO   )= +( 1.000)*r(  3)+( 1.000)*r(  6)+( 1.000)*r( 15)
     &                +( 2.000)*r( 20)+( 1.000)*r( 21)+( 1.000)*r( 22)
     &                +( 1.000)*r( 28)+( 1.000)*r( 46)+( 1.000)*r( 64)
     &                +( 1.000)*r( 79)+( 1.000)*r( 81)+( 1.000)*r(100)
        Gain(lNO   )= +( 1.000)*r(  1)+( 1.000)*r(  4)+( 0.110)*r( 14)
     &                +( 1.000)*r( 16)+( 1.000)*r( 23)+( 1.000)*r( 25)
     &                +( 0.200)*r( 96)
        Loss(lO    )= +( 1.000)*r(  2)+( 1.000)*r(  4)+( 1.000)*r(  5)
     &                +( 1.000)*r(  6)+( 1.000)*r( 40)+( 1.000)*r( 42)
     &                +( 1.000)*r( 56)+( 1.000)*r( 60)+( 1.000)*r( 75)
        Gain(lO    )= +( 1.000)*r(  1)+( 1.000)*r(  8)+( 1.000)*r( 10)
     &                +( 0.890)*r( 14)
        Loss(lO3   )= +( 1.000)*r(  3)+( 1.000)*r(  7)+( 1.000)*r(  8)
     &                +( 1.000)*r(  9)+( 1.000)*r( 12)+( 1.000)*r( 13)
     &                +( 1.000)*r( 58)+( 1.000)*r( 62)+( 1.000)*r( 71)
     &                +( 1.000)*r( 77)+( 1.000)*r( 93)+( 1.000)*r( 99)
        Gain(lO3   )= +( 1.000)*r(  2)
        Loss(lNO3  )= +( 1.000)*r( 14)+( 1.000)*r( 15)+( 1.000)*r( 16)
     &                +( 1.000)*r( 17)+( 1.000)*r( 41)+( 1.000)*r( 44)
     &                +( 1.000)*r( 59)+( 1.000)*r( 67)+( 1.000)*r( 78)
     &                +( 1.000)*r( 94)
        Gain(lNO3  )= +( 1.000)*r(  5)+( 1.000)*r(  7)+( 1.000)*r( 19)
     &                +( 1.000)*r( 27)
        Loss(lO1D  )= +( 1.000)*r( 10)+( 1.000)*r( 11)
        Gain(lO1D  )= +( 1.000)*r(  9)
        Loss(lOH   )= +( 1.000)*r( 12)+( 1.000)*r( 22)+( 1.000)*r( 24)
     &                +( 1.000)*r( 26)+( 1.000)*r( 27)+( 1.000)*r( 31)
     &                +( 1.000)*r( 35)+( 1.000)*r( 36)+( 1.000)*r( 37)
     &                +( 1.000)*r( 43)+( 1.000)*r( 51)+( 1.000)*r( 52)
     &                +( 1.000)*r( 57)+( 1.000)*r( 61)+( 1.000)*r( 63)
     &                +( 1.000)*r( 66)+( 1.000)*r( 70)+( 1.000)*r( 72)
     &                +( 1.000)*r( 73)+( 1.000)*r( 76)+( 1.000)*r( 82)
     &                +( 1.000)*r( 84)+( 1.000)*r( 85)+( 1.000)*r( 90)
     &                +( 1.000)*r( 92)+( 1.000)*r(107)+( 1.000)*r(109)
        Gain(lOH   )= +( 2.000)*r( 11)+( 1.000)*r( 13)+( 1.000)*r( 23)
     &                +( 1.000)*r( 28)+( 2.000)*r( 34)+( 1.000)*r( 40)
     &                +( 1.000)*r( 42)+( 0.790)*r( 50)+( 0.200)*r( 56)
     &                +( 0.100)*r( 58)+( 0.300)*r( 60)+( 0.080)*r( 71)
     &                +( 0.266)*r( 77)+( 0.268)*r( 93)+( 1.000)*r( 98)
        Loss(lHO2  )= +( 1.000)*r( 13)+( 1.000)*r( 28)+( 1.000)*r( 29)
     &                +( 2.000)*r( 32)+( 2.000)*r( 33)+( 1.000)*r( 50)
     &                +( 1.000)*r( 86)+( 1.000)*r( 87)+( 1.000)*r( 90)
     &                +( 1.000)*r(101)
        Gain(lHO2  )= +( 1.000)*r( 12)+( 1.000)*r( 30)+( 1.000)*r( 35)
     &                +( 1.000)*r( 36)+( 1.000)*r( 37)+( 2.000)*r( 38)
     &                +( 1.000)*r( 40)+( 1.000)*r( 41)+( 2.000)*r( 45)
     &                +( 1.000)*r( 46)+( 2.000)*r( 49)+( 0.790)*r( 50)
     &                +( 1.000)*r( 51)+( 0.110)*r( 52)+( 0.940)*r( 53)
     &                +( 1.000)*r( 54)+( 0.380)*r( 56)+( 1.000)*r( 57)
     &                +( 0.440)*r( 58)+( 1.700)*r( 60)+( 1.000)*r( 61)
     &                +( 0.120)*r( 62)+( 0.440)*r( 63)+( 0.900)*r( 64)
     &                +( 1.000)*r( 65)+( 0.600)*r( 66)+( 1.000)*r( 69)
        Gain(lHO2  ) = Gain(lHO2  )
     &                +( 2.000)*r( 70)+( 0.760)*r( 71)+( 0.700)*r( 72)
     &                +( 1.000)*r( 74)+( 0.250)*r( 75)+( 0.912)*r( 76)
     &                +( 0.066)*r( 77)+( 0.800)*r( 78)+( 1.000)*r( 82)
     &                +( 1.000)*r( 84)+( 1.000)*r( 85)+( 0.503)*r( 92)
     &                +( 0.154)*r( 93)+( 0.925)*r( 94)+( 1.033)*r( 95)
     &                +( 0.800)*r( 96)+( 1.000)*r(103)+( 1.000)*r(104)
     &                +( 1.000)*r(105)+( 1.000)*r(106)+( 1.000)*r(108)
        Loss(lN2O5 )= +( 1.000)*r( 18)+( 1.000)*r( 19)
        Gain(lN2O5 )= +( 1.000)*r( 17)
        Loss(lHNO3 )= +( 1.000)*r( 27)
        Gain(lHNO3 )= +( 2.000)*r( 18)+( 1.000)*r( 26)+( 1.000)*r( 41)
     &                +( 1.000)*r( 44)+( 1.000)*r( 67)+( 0.150)*r( 94)
        Loss(lHONO )= +( 1.000)*r( 23)+( 1.000)*r( 24)+( 2.000)*r( 25)
        Gain(lHONO )= +( 2.000)*r( 21)+( 1.000)*r( 22)
        Loss(lPNA  )= +( 1.000)*r( 30)+( 1.000)*r( 31)
        Gain(lPNA  )= +( 1.000)*r( 29)
        Loss(lH2O2 )= +( 1.000)*r( 34)+( 1.000)*r( 35)
        Gain(lH2O2 )= +( 1.000)*r( 32)+( 1.000)*r( 33)
        Loss(lCO   )= +( 1.000)*r( 36)
        Gain(lCO   )= +( 1.000)*r( 37)+( 1.000)*r( 38)+( 1.000)*r( 39)
     &                +( 1.000)*r( 40)+( 1.000)*r( 41)+( 1.000)*r( 45)
     &                +( 0.300)*r( 56)+( 0.330)*r( 58)+( 1.000)*r( 60)
     &                +( 0.420)*r( 62)+( 1.000)*r( 69)+( 2.000)*r( 70)
     &                +( 0.690)*r( 71)+( 1.000)*r( 74)+( 0.066)*r( 77)
     &                +( 0.334)*r( 92)+( 0.225)*r( 93)+( 0.643)*r( 94)
     &                +( 0.333)*r( 95)
        Loss(lFORM )= +( 1.000)*r( 37)+( 1.000)*r( 38)+( 1.000)*r( 39)
     &                +( 1.000)*r( 40)+( 1.000)*r( 41)
        Gain(lFORM )= +( 1.000)*r( 45)+( 1.000)*r( 46)+( 2.000)*r( 49)
     &                +( 0.790)*r( 50)+( 1.000)*r( 51)+( 0.200)*r( 56)
     &                +( 1.000)*r( 57)+( 0.740)*r( 58)+( 1.000)*r( 59)
     &                +( 1.000)*r( 60)+( 1.560)*r( 61)+( 1.000)*r( 62)
     &                +( 1.000)*r( 70)+( 0.700)*r( 71)+( 0.500)*r( 75)
     &                +( 0.629)*r( 76)+( 0.600)*r( 77)+( 1.000)*r( 84)
     &                +( 0.167)*r( 92)+( 0.150)*r( 93)+( 0.282)*r( 94)
     &                +( 0.900)*r( 95)+( 1.000)*r(104)+( 1.000)*r(105)
        Loss(lALD2 )= +( 1.000)*r( 42)+( 1.000)*r( 43)+( 1.000)*r( 44)
     &                +( 1.000)*r( 45)
        Gain(lALD2 )= +( 0.110)*r( 52)+( 1.100)*r( 53)+( 0.630)*r( 56)
     &                +( 1.000)*r( 57)+( 0.500)*r( 58)+( 1.000)*r( 59)
     &                +( 0.220)*r( 61)+( 0.030)*r( 71)+( 0.150)*r( 77)
     &                +( 0.800)*r( 78)+( 1.000)*r( 85)+( 0.273)*r( 92)
     &                +( 0.020)*r( 93)+( 0.357)*r( 94)+( 0.067)*r( 95)
     &                +( 0.800)*r( 96)
        Loss(lC2O3 )= +( 1.000)*r( 46)+( 1.000)*r( 47)+( 2.000)*r( 49)
     &                +( 1.000)*r( 50)
        Gain(lC2O3 )= +( 1.000)*r( 42)+( 1.000)*r( 43)+( 1.000)*r( 44)
     &                +( 1.000)*r( 48)+( 1.000)*r( 69)+( 1.000)*r( 70)
     &                +( 0.620)*r( 71)+( 1.000)*r( 73)+( 1.000)*r( 74)
     &                +( 0.250)*r( 75)+( 0.200)*r( 77)+( 0.498)*r( 92)
     &                +( 0.114)*r( 93)+( 0.075)*r( 94)+( 0.967)*r( 95)
        Loss(lXO2  )= +( 1.000)*r( 79)+( 2.000)*r( 80)+( 1.000)*r( 86)
     &                +( 1.000)*r( 89)
        Gain(lXO2  )= +( 1.000)*r( 45)+( 1.000)*r( 46)+( 2.000)*r( 49)
     &                +( 0.790)*r( 50)+( 1.000)*r( 51)+( 0.870)*r( 52)
     &                +( 0.960)*r( 53)+( 0.280)*r( 56)+( 1.000)*r( 57)
     &                +( 0.220)*r( 58)+( 0.910)*r( 59)+( 0.700)*r( 60)
     &                +( 1.000)*r( 61)+( 0.080)*r( 63)+( 0.600)*r( 66)
     &                +( 1.000)*r( 70)+( 0.030)*r( 71)+( 0.500)*r( 72)
     &                +( 1.000)*r( 73)+( 0.250)*r( 75)+( 0.991)*r( 76)
     &                +( 0.200)*r( 77)+( 1.000)*r( 78)+( 0.713)*r( 92)
     &                +( 0.064)*r( 93)+( 0.075)*r( 94)+( 0.700)*r( 95)
        Gain(lXO2  ) = Gain(lXO2  )
     &                +( 1.000)*r( 96)+( 0.870)*r(102)+( 2.000)*r(103)
     &                +( 1.000)*r(104)+( 2.000)*r(105)+( 1.000)*r(106)
     &                +( 1.000)*r(108)
        Loss(lPAN  )= +( 1.000)*r( 48)
        Gain(lPAN  )= +( 1.000)*r( 47)
        Loss(lPAR  )= +( 1.000)*r( 52)+( 1.000)*r(102)
        Gain(lPAR  )= +(-0.110)*r( 52)+(-2.100)*r( 53)+( 0.220)*r( 56)
     &                +(-1.000)*r( 57)+(-1.000)*r( 58)+(-1.000)*r( 59)
     &                +( 1.100)*r( 72)+( 0.250)*r( 75)+( 0.350)*r( 77)
     &                +( 2.400)*r( 78)+( 1.565)*r( 92)+( 0.360)*r( 93)
     &                +( 1.282)*r( 94)+( 0.832)*r( 95)+( 2.400)*r( 96)
     &                +(-0.110)*r(102)+(-1.000)*r(103)
        Loss(lXO2N )= +( 1.000)*r( 81)+( 1.000)*r( 87)+( 2.000)*r( 88)
     &                +( 1.000)*r( 89)
        Gain(lXO2N )= +( 0.130)*r( 52)+( 0.040)*r( 53)+( 0.020)*r( 56)
     &                +( 0.090)*r( 59)+( 0.088)*r( 76)+( 0.130)*r(102)
        Loss(lROR  )= +( 1.000)*r( 53)+( 1.000)*r( 54)+( 1.000)*r( 55)
        Gain(lROR  )= +( 0.760)*r( 52)+( 0.760)*r(102)

        Gain(lNTR  )= +( 1.000)*r( 55)+( 0.100)*r( 64)+( 1.000)*r( 68)
     &                +( 0.800)*r( 78)+( 1.000)*r( 81)+( 0.850)*r( 94)
     &                +( 0.800)*r( 96)
        Loss(lOLE  )= +( 1.000)*r( 56)+( 1.000)*r( 57)+( 1.000)*r( 58)
     &                +( 1.000)*r( 59)+( 1.000)*r(103)

        Loss(lETH  )= +( 1.000)*r( 60)+( 1.000)*r( 61)+( 1.000)*r( 62)
     &                +( 1.000)*r(105)

        Loss(lTOL  )= +( 1.000)*r( 63)

        Loss(lCRES )= +( 1.000)*r( 66)+( 1.000)*r( 67)
        Gain(lCRES )= +( 0.360)*r( 63)+( 1.000)*r( 65)+( 0.200)*r( 72)
        Loss(lTO2  )= +( 1.000)*r( 64)+( 1.000)*r( 65)
        Gain(lTO2  )= +( 0.560)*r( 63)+( 0.300)*r( 72)
        Loss(lOPEN )= +( 1.000)*r( 69)+( 1.000)*r( 70)+( 1.000)*r( 71)
        Gain(lOPEN )= +( 0.900)*r( 64)+( 0.300)*r( 66)
        Loss(lCRO  )= +( 1.000)*r( 68)+( 1.000)*r( 91)
        Gain(lCRO  )= +( 0.400)*r( 66)+( 1.000)*r( 67)
        Loss(lMGLY )= +( 1.000)*r( 73)+( 1.000)*r( 74)
        Gain(lMGLY )= +( 0.200)*r( 71)+( 0.800)*r( 72)+( 0.168)*r( 92)
     &                +( 0.850)*r( 93)
        Loss(lXYL  )= +( 1.000)*r( 72)

        Loss(lISOP )= +( 1.000)*r( 75)+( 1.000)*r( 76)+( 1.000)*r( 77)
     &                +( 1.000)*r( 78)+( 1.000)*r( 96)+( 1.000)*r(106)

        Loss(lISPD )= +( 1.000)*r( 92)+( 1.000)*r( 93)+( 1.000)*r( 94)
     &                +( 1.000)*r( 95)
        Gain(lISPD )= +( 0.750)*r( 75)+( 0.912)*r( 76)+( 0.650)*r( 77)
     &                +( 0.200)*r( 78)+( 0.200)*r( 96)
        Loss(lSO2  )= +( 1.000)*r( 82)+( 1.000)*r( 83)


        Gain(lSULF )= +( 1.000)*r( 82)+( 1.000)*r( 83)
        Loss(lMEOH )= +( 1.000)*r( 84)

        Loss(lETOH )= +( 1.000)*r( 85)

        Loss(lCL2  )= +( 1.000)*r( 97)
        Gain(lCL2  )= +( 0.300)*r(110)
        Loss(lCL   )= +( 1.000)*r( 99)+( 1.000)*r(102)+( 1.000)*r(103)
     &                +( 1.000)*r(104)+( 1.000)*r(105)+( 1.000)*r(106)
     &                +( 1.000)*r(108)
        Gain(lCL   )= +( 2.000)*r( 97)+( 1.000)*r( 98)+( 1.000)*r(100)
     &                +( 1.400)*r(110)
        Loss(lHOCL )= +( 1.000)*r( 98)
        Gain(lHOCL )= +( 1.000)*r(101)
        Loss(lCLO  )= +( 1.000)*r(100)+( 1.000)*r(101)+( 2.000)*r(110)
        Gain(lCLO  )= +( 1.000)*r( 99)

        Gain(lHCL  )= +( 1.000)*r(102)+( 1.000)*r(104)+( 0.150)*r(106)

        Gain(lRCHO )= +( 0.110)*r(102)+( 1.000)*r(103)

        Gain(lFMCL )= +( 1.000)*r(103)+( 1.000)*r(105)
        Loss(lICL1 )= +( 1.000)*r(107)
        Gain(lICL1 )= +( 0.280)*r(106)

        Gain(lICL2 )= +( 1.000)*r(107)
        Loss(lBUTA )= +( 1.000)*r(108)

        Loss(lBCL1 )= +( 1.000)*r(109)
        Gain(lBCL1 )= +( 0.700)*r(108)

        Gain(lBCL2 )= +( 1.000)*r(109)
c
      do l=1,neq
        rate(l) = gain(l) -loss(l)
      enddo
c
      return
      end
